//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_rest_api_ns0_authentication_settings_H
#define DEF_nexus_rest_api_ns0_authentication_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_authentication_settings {


  /**
   * (no documentation provided)
   */
  xmlChar *password;

  /**
   * (no documentation provided)
   */
  xmlChar *username;

  /**
   * (no documentation provided)
   */
  xmlChar *ntlmDomain;

  /**
   * (no documentation provided)
   */
  xmlChar *ntlmHost;
};

/**
 * Reads a AuthenticationSettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The AuthenticationSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_authentication_settings *xmlTextReaderReadNs0Authentication_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a AuthenticationSettings to XML.
 *
 * @param writer The XML writer.
 * @param _authenticationSettings The AuthenticationSettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Authentication_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_authentication_settings *_authenticationSettings);

/**
 * Frees the elements of a AuthenticationSettings.
 *
 * @param _authenticationSettings The AuthenticationSettings to free.
 */
static void freeNs0Authentication_settingsType(struct nexus_rest_api_ns0_authentication_settings *_authenticationSettings);

#endif /* DEF_nexus_rest_api_ns0_authentication_settings_H */
#ifndef DEF_nexus_rest_api_ns0_errorReportRequest_H
#define DEF_nexus_rest_api_ns0_errorReportRequest_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_errorReportRequest {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_error_report_request_dto *data;
};

/**
 * Reads a ErrorReportRequest element from XML. The element to be read is "error-report-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ErrorReportRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_errorReportRequest *xml_read_nexus_rest_api_ns0_errorReportRequest(xmlTextReaderPtr reader);

/**
 * Writes a ErrorReportRequest to XML under element name "error-report-request".
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_errorReportRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest);

/**
 * Frees a ErrorReportRequest.
 *
 * @param _errorReportRequest The ErrorReportRequest to free.
 */
void free_nexus_rest_api_ns0_errorReportRequest(struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest);

/**
 * Reads a ErrorReportRequest element from XML. The element to be read is "error-report-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ErrorReportRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_errorReportRequest *xmlTextReaderReadNs0Error_report_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a ErrorReportRequest to XML under element name "error-report-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Error_report_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest);

/**
 * Writes a ErrorReportRequest to XML under element name "error-report-request".
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Error_report_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest, int writeNamespaces);

/**
 * Frees the children of a ErrorReportRequest.
 *
 * @param _errorReportRequest The ErrorReportRequest whose children are to be free.
 */
static void freeNs0Error_report_requestElement(struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest);

/**
 * Reads a ErrorReportRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ErrorReportRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_errorReportRequest *xmlTextReaderReadNs0ErrorReportRequestType(xmlTextReaderPtr reader);

/**
 * Writes a ErrorReportRequest to XML.
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ErrorReportRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest);

/**
 * Frees the elements of a ErrorReportRequest.
 *
 * @param _errorReportRequest The ErrorReportRequest to free.
 */
static void freeNs0ErrorReportRequestType(struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest);

#endif /* DEF_nexus_rest_api_ns0_errorReportRequest_H */
#ifndef DEF_nexus_rest_api_ns0_error_report_request_dto_H
#define DEF_nexus_rest_api_ns0_error_report_request_dto_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_error_report_request_dto {


  /**
   * (no documentation provided)
   */
  xmlChar *description;

  /**
   * (no documentation provided)
   */
  xmlChar *title;

  /**
   * (no documentation provided)
   */
  int saveErrorReportingSettings;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_error_reporting_settings *errorReportingSettings;
};

/**
 * Reads a ErrorReportRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ErrorReportRequestDTO, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_error_report_request_dto *xmlTextReaderReadNs0Error_report_request_dtoType(xmlTextReaderPtr reader);

/**
 * Writes a ErrorReportRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _errorReportRequestDTO The ErrorReportRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Error_report_request_dtoType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_error_report_request_dto *_errorReportRequestDTO);

/**
 * Frees the elements of a ErrorReportRequestDTO.
 *
 * @param _errorReportRequestDTO The ErrorReportRequestDTO to free.
 */
static void freeNs0Error_report_request_dtoType(struct nexus_rest_api_ns0_error_report_request_dto *_errorReportRequestDTO);

#endif /* DEF_nexus_rest_api_ns0_error_report_request_dto_H */
#ifndef DEF_nexus_rest_api_ns0_error_reporting_settings_H
#define DEF_nexus_rest_api_ns0_error_reporting_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_error_reporting_settings {


  /**
   * (no documentation provided)
   */
  xmlChar *jiraUsername;

  /**
   * (no documentation provided)
   */
  int reportErrorsAutomatically;

  /**
   * (no documentation provided)
   */
  int useGlobalProxy;

  /**
   * (no documentation provided)
   */
  xmlChar *jiraPassword;
};

/**
 * Reads a ErrorReportingSettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ErrorReportingSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_error_reporting_settings *xmlTextReaderReadNs0Error_reporting_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a ErrorReportingSettings to XML.
 *
 * @param writer The XML writer.
 * @param _errorReportingSettings The ErrorReportingSettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Error_reporting_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_error_reporting_settings *_errorReportingSettings);

/**
 * Frees the elements of a ErrorReportingSettings.
 *
 * @param _errorReportingSettings The ErrorReportingSettings to free.
 */
static void freeNs0Error_reporting_settingsType(struct nexus_rest_api_ns0_error_reporting_settings *_errorReportingSettings);

#endif /* DEF_nexus_rest_api_ns0_error_reporting_settings_H */
#ifndef DEF_nexus_rest_api_ns0_global_settings_item_H
#define DEF_nexus_rest_api_ns0_global_settings_item_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_global_settings_item {


  /**
   * (no documentation provided)
   */
  int securityEnabled;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_remote_connection_settings *globalConnectionSettings;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_remote_http_proxy_settings *globalHttpProxySettings;

  /**
   * (no documentation provided)
   */
  xmlChar *securityRealms;

  /**
   * Size of the securityRealms array.
   */
  int _sizeof_securityRealms;

  /**
   * (no documentation provided)
   */
  xmlChar *securityAnonymousUsername;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_smtp_settings *smtpSettings;

  /**
   * (no documentation provided)
   */
  xmlChar *securityAnonymousPassword;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_rest_api_settings *globalRestApiSettings;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_error_reporting_settings *errorReportingSettings;

  /**
   * (no documentation provided)
   */
  int securityAnonymousAccessEnabled;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_system_notification_settings *systemNotificationSettings;
};

/**
 * Reads a GlobalConfigurationResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The GlobalConfigurationResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_global_settings_item *xmlTextReaderReadNs0Global_settings_itemType(xmlTextReaderPtr reader);

/**
 * Writes a GlobalConfigurationResource to XML.
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResource The GlobalConfigurationResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Global_settings_itemType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_global_settings_item *_globalConfigurationResource);

/**
 * Frees the elements of a GlobalConfigurationResource.
 *
 * @param _globalConfigurationResource The GlobalConfigurationResource to free.
 */
static void freeNs0Global_settings_itemType(struct nexus_rest_api_ns0_global_settings_item *_globalConfigurationResource);

#endif /* DEF_nexus_rest_api_ns0_global_settings_item_H */
#ifndef DEF_nexus_rest_api_ns0_globalConfigurationResourceResponse_H
#define DEF_nexus_rest_api_ns0_globalConfigurationResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_globalConfigurationResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_global_settings_item *data;
};

/**
 * Reads a GlobalConfigurationResourceResponse element from XML. The element to be read is "global-settings", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The GlobalConfigurationResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_globalConfigurationResourceResponse *xml_read_nexus_rest_api_ns0_globalConfigurationResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a GlobalConfigurationResourceResponse to XML under element name "global-settings".
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_globalConfigurationResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse);

/**
 * Frees a GlobalConfigurationResourceResponse.
 *
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to free.
 */
void free_nexus_rest_api_ns0_globalConfigurationResourceResponse(struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse);

/**
 * Reads a GlobalConfigurationResourceResponse element from XML. The element to be read is "global-settings", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The GlobalConfigurationResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_globalConfigurationResourceResponse *xmlTextReaderReadNs0Global_settingsElement(xmlTextReaderPtr reader);

/**
 * Writes a GlobalConfigurationResourceResponse to XML under element name "global-settings".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Global_settingsElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse);

/**
 * Writes a GlobalConfigurationResourceResponse to XML under element name "global-settings".
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Global_settingsElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse, int writeNamespaces);

/**
 * Frees the children of a GlobalConfigurationResourceResponse.
 *
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse whose children are to be free.
 */
static void freeNs0Global_settingsElement(struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse);

/**
 * Reads a GlobalConfigurationResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The GlobalConfigurationResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_globalConfigurationResourceResponse *xmlTextReaderReadNs0GlobalConfigurationResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a GlobalConfigurationResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0GlobalConfigurationResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse);

/**
 * Frees the elements of a GlobalConfigurationResourceResponse.
 *
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to free.
 */
static void freeNs0GlobalConfigurationResourceResponseType(struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_globalConfigurationResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_log_config_resource_H
#define DEF_nexus_rest_api_ns0_log_config_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_log_config_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *rootLoggerAppenders;

  /**
   * (no documentation provided)
   */
  xmlChar *fileAppenderLocation;

  /**
   * (no documentation provided)
   */
  xmlChar *fileAppenderPattern;

  /**
   * (no documentation provided)
   */
  xmlChar *rootLoggerLevel;
};

/**
 * Reads a LogConfigResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LogConfigResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_log_config_resource *xmlTextReaderReadNs0Log_config_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a LogConfigResource to XML.
 *
 * @param writer The XML writer.
 * @param _logConfigResource The LogConfigResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Log_config_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_log_config_resource *_logConfigResource);

/**
 * Frees the elements of a LogConfigResource.
 *
 * @param _logConfigResource The LogConfigResource to free.
 */
static void freeNs0Log_config_resourceType(struct nexus_rest_api_ns0_log_config_resource *_logConfigResource);

#endif /* DEF_nexus_rest_api_ns0_log_config_resource_H */
#ifndef DEF_nexus_rest_api_ns0_logConfigResourceResponse_H
#define DEF_nexus_rest_api_ns0_logConfigResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_logConfigResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_log_config_resource *data;
};

/**
 * Reads a LogConfigResourceResponse element from XML. The element to be read is "log-config", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LogConfigResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_logConfigResourceResponse *xml_read_nexus_rest_api_ns0_logConfigResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a LogConfigResourceResponse to XML under element name "log-config".
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_logConfigResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse);

/**
 * Frees a LogConfigResourceResponse.
 *
 * @param _logConfigResourceResponse The LogConfigResourceResponse to free.
 */
void free_nexus_rest_api_ns0_logConfigResourceResponse(struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse);

/**
 * Reads a LogConfigResourceResponse element from XML. The element to be read is "log-config", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LogConfigResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_logConfigResourceResponse *xmlTextReaderReadNs0Log_configElement(xmlTextReaderPtr reader);

/**
 * Writes a LogConfigResourceResponse to XML under element name "log-config".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Log_configElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse);

/**
 * Writes a LogConfigResourceResponse to XML under element name "log-config".
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Log_configElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse, int writeNamespaces);

/**
 * Frees the children of a LogConfigResourceResponse.
 *
 * @param _logConfigResourceResponse The LogConfigResourceResponse whose children are to be free.
 */
static void freeNs0Log_configElement(struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse);

/**
 * Reads a LogConfigResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LogConfigResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_logConfigResourceResponse *xmlTextReaderReadNs0LogConfigResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a LogConfigResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LogConfigResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse);

/**
 * Frees the elements of a LogConfigResourceResponse.
 *
 * @param _logConfigResourceResponse The LogConfigResourceResponse to free.
 */
static void freeNs0LogConfigResourceResponseType(struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_logConfigResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_mirror_resource_H
#define DEF_nexus_rest_api_ns0_mirror_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_mirror_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *url;
};

/**
 * Reads a MirrorResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The MirrorResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_mirror_resource *xmlTextReaderReadNs0Mirror_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a MirrorResource to XML.
 *
 * @param writer The XML writer.
 * @param _mirrorResource The MirrorResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Mirror_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirror_resource *_mirrorResource);

/**
 * Frees the elements of a MirrorResource.
 *
 * @param _mirrorResource The MirrorResource to free.
 */
static void freeNs0Mirror_resourceType(struct nexus_rest_api_ns0_mirror_resource *_mirrorResource);

#endif /* DEF_nexus_rest_api_ns0_mirror_resource_H */
#ifndef DEF_nexus_rest_api_ns0_mirrorResourceListRequest_H
#define DEF_nexus_rest_api_ns0_mirrorResourceListRequest_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_mirrorResourceListRequest {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_mirror_resource *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a MirrorResourceListRequest element from XML. The element to be read is "mirror-list-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The MirrorResourceListRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_mirrorResourceListRequest *xml_read_nexus_rest_api_ns0_mirrorResourceListRequest(xmlTextReaderPtr reader);

/**
 * Writes a MirrorResourceListRequest to XML under element name "mirror-list-request".
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_mirrorResourceListRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest);

/**
 * Frees a MirrorResourceListRequest.
 *
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to free.
 */
void free_nexus_rest_api_ns0_mirrorResourceListRequest(struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest);

/**
 * Reads a MirrorResourceListRequest element from XML. The element to be read is "mirror-list-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The MirrorResourceListRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_mirrorResourceListRequest *xmlTextReaderReadNs0Mirror_list_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a MirrorResourceListRequest to XML under element name "mirror-list-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Mirror_list_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest);

/**
 * Writes a MirrorResourceListRequest to XML under element name "mirror-list-request".
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Mirror_list_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest, int writeNamespaces);

/**
 * Frees the children of a MirrorResourceListRequest.
 *
 * @param _mirrorResourceListRequest The MirrorResourceListRequest whose children are to be free.
 */
static void freeNs0Mirror_list_requestElement(struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest);

/**
 * Reads a MirrorResourceListRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The MirrorResourceListRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_mirrorResourceListRequest *xmlTextReaderReadNs0MirrorResourceListRequestType(xmlTextReaderPtr reader);

/**
 * Writes a MirrorResourceListRequest to XML.
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0MirrorResourceListRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest);

/**
 * Frees the elements of a MirrorResourceListRequest.
 *
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to free.
 */
static void freeNs0MirrorResourceListRequestType(struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest);

#endif /* DEF_nexus_rest_api_ns0_mirrorResourceListRequest_H */
#ifndef DEF_nexus_rest_api_ns0_nexusResponse_H
#define DEF_nexus_rest_api_ns0_nexusResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_nexusResponse {

};

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader);

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_nexusResponse *_nexusResponse);

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_rest_api_ns0_nexusResponse *_nexusResponse);

#endif /* DEF_nexus_rest_api_ns0_nexusResponse_H */
#ifndef DEF_nexus_rest_api_ns0_privilege_H
#define DEF_nexus_rest_api_ns0_privilege_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_privilege {


  /**
   * (no documentation provided)
   */
  xmlChar *repositoryId;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryTargetId;

  /**
   * (no documentation provided)
   */
  xmlChar *description;

  /**
   * (no documentation provided)
   */
  xmlChar *type;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *method;

  /**
   * Size of the method array.
   */
  int _sizeof_method;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryGroupId;
};

/**
 * Reads a PrivilegeResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PrivilegeResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_privilege *xmlTextReaderReadNs0PrivilegeType(xmlTextReaderPtr reader);

/**
 * Writes a PrivilegeResource to XML.
 *
 * @param writer The XML writer.
 * @param _privilegeResource The PrivilegeResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PrivilegeType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilege *_privilegeResource);

/**
 * Frees the elements of a PrivilegeResource.
 *
 * @param _privilegeResource The PrivilegeResource to free.
 */
static void freeNs0PrivilegeType(struct nexus_rest_api_ns0_privilege *_privilegeResource);

#endif /* DEF_nexus_rest_api_ns0_privilege_H */
#ifndef DEF_nexus_rest_api_ns0_privilegeResourceRequest_H
#define DEF_nexus_rest_api_ns0_privilegeResourceRequest_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_privilegeResourceRequest {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_privilege *data;
};

/**
 * Reads a PrivilegeResourceRequest element from XML. The element to be read is "privilege-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The PrivilegeResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_privilegeResourceRequest *xml_read_nexus_rest_api_ns0_privilegeResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a PrivilegeResourceRequest to XML under element name "privilege-request".
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_privilegeResourceRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest);

/**
 * Frees a PrivilegeResourceRequest.
 *
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to free.
 */
void free_nexus_rest_api_ns0_privilegeResourceRequest(struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest);

/**
 * Reads a PrivilegeResourceRequest element from XML. The element to be read is "privilege-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The PrivilegeResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_privilegeResourceRequest *xmlTextReaderReadNs0Privilege_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a PrivilegeResourceRequest to XML under element name "privilege-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Privilege_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest);

/**
 * Writes a PrivilegeResourceRequest to XML under element name "privilege-request".
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Privilege_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest, int writeNamespaces);

/**
 * Frees the children of a PrivilegeResourceRequest.
 *
 * @param _privilegeResourceRequest The PrivilegeResourceRequest whose children are to be free.
 */
static void freeNs0Privilege_requestElement(struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest);

/**
 * Reads a PrivilegeResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PrivilegeResourceRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_privilegeResourceRequest *xmlTextReaderReadNs0PrivilegeResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a PrivilegeResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PrivilegeResourceRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest);

/**
 * Frees the elements of a PrivilegeResourceRequest.
 *
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to free.
 */
static void freeNs0PrivilegeResourceRequestType(struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest);

#endif /* DEF_nexus_rest_api_ns0_privilegeResourceRequest_H */
#ifndef DEF_nexus_rest_api_ns0_remote_connection_settings_H
#define DEF_nexus_rest_api_ns0_remote_connection_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_remote_connection_settings {


  /**
   * (no documentation provided)
   */
  xmlChar *userAgentString;

  /**
   * (no documentation provided)
   */
  int retrievalRetryCount;

  /**
   * (no documentation provided)
   */
  xmlChar *queryString;

  /**
   * (no documentation provided)
   */
  int connectionTimeout;
};

/**
 * Reads a RemoteConnectionSettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RemoteConnectionSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_remote_connection_settings *xmlTextReaderReadNs0Remote_connection_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a RemoteConnectionSettings to XML.
 *
 * @param writer The XML writer.
 * @param _remoteConnectionSettings The RemoteConnectionSettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Remote_connection_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_remote_connection_settings *_remoteConnectionSettings);

/**
 * Frees the elements of a RemoteConnectionSettings.
 *
 * @param _remoteConnectionSettings The RemoteConnectionSettings to free.
 */
static void freeNs0Remote_connection_settingsType(struct nexus_rest_api_ns0_remote_connection_settings *_remoteConnectionSettings);

#endif /* DEF_nexus_rest_api_ns0_remote_connection_settings_H */
#ifndef DEF_nexus_rest_api_ns0_remote_http_proxy_settings_H
#define DEF_nexus_rest_api_ns0_remote_http_proxy_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_remote_http_proxy_settings {


  /**
   * (no documentation provided)
   */
  xmlChar *nonProxyHosts;

  /**
   * Size of the nonProxyHosts array.
   */
  int _sizeof_nonProxyHosts;

  /**
   * (no documentation provided)
   */
  int proxyPort;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_authentication_settings *authentication;

  /**
   * (no documentation provided)
   */
  xmlChar *proxyHostname;
};

/**
 * Reads a RemoteHttpProxySettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RemoteHttpProxySettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_remote_http_proxy_settings *xmlTextReaderReadNs0Remote_http_proxy_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a RemoteHttpProxySettings to XML.
 *
 * @param writer The XML writer.
 * @param _remoteHttpProxySettings The RemoteHttpProxySettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Remote_http_proxy_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_remote_http_proxy_settings *_remoteHttpProxySettings);

/**
 * Frees the elements of a RemoteHttpProxySettings.
 *
 * @param _remoteHttpProxySettings The RemoteHttpProxySettings to free.
 */
static void freeNs0Remote_http_proxy_settingsType(struct nexus_rest_api_ns0_remote_http_proxy_settings *_remoteHttpProxySettings);

#endif /* DEF_nexus_rest_api_ns0_remote_http_proxy_settings_H */
#ifndef DEF_nexus_rest_api_ns0_base_repository_H
#define DEF_nexus_rest_api_ns0_base_repository_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_base_repository {


  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *provider;

  /**
   * (no documentation provided)
   */
  int exposed;

  /**
   * (no documentation provided)
   */
  xmlChar *repoType;

  /**
   * (no documentation provided)
   */
  xmlChar *format;

  /**
   * (no documentation provided)
   */
  xmlChar *providerRole;

  /**
   * (no documentation provided)
   */
  xmlChar *contentResourceURI;
};

/**
 * Reads a RepositoryBaseResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryBaseResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_base_repository *xmlTextReaderReadNs0Base_repositoryType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryBaseResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryBaseResource The RepositoryBaseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Base_repositoryType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_base_repository *_repositoryBaseResource);

/**
 * Frees the elements of a RepositoryBaseResource.
 *
 * @param _repositoryBaseResource The RepositoryBaseResource to free.
 */
static void freeNs0Base_repositoryType(struct nexus_rest_api_ns0_base_repository *_repositoryBaseResource);

#endif /* DEF_nexus_rest_api_ns0_base_repository_H */
#ifndef DEF_nexus_rest_api_ns0_repository_dependent_status_H
#define DEF_nexus_rest_api_ns0_repository_dependent_status_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_dependent_status {


  /**
   * (no documentation provided)
   */
  xmlChar *localStatus;

  /**
   * (no documentation provided)
   */
  xmlChar *format;

  /**
   * (no documentation provided)
   */
  xmlChar *repoType;

  /**
   * (no documentation provided)
   */
  xmlChar *id;
};

/**
 * Reads a RepositoryDependentStatusResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryDependentStatusResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_dependent_status *xmlTextReaderReadNs0Repository_dependent_statusType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryDependentStatusResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryDependentStatusResource The RepositoryDependentStatusResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_dependent_statusType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_dependent_status *_repositoryDependentStatusResource);

/**
 * Frees the elements of a RepositoryDependentStatusResource.
 *
 * @param _repositoryDependentStatusResource The RepositoryDependentStatusResource to free.
 */
static void freeNs0Repository_dependent_statusType(struct nexus_rest_api_ns0_repository_dependent_status *_repositoryDependentStatusResource);

#endif /* DEF_nexus_rest_api_ns0_repository_dependent_status_H */
#ifndef DEF_nexus_rest_api_ns0_repository_group_member_repository_H
#define DEF_nexus_rest_api_ns0_repository_group_member_repository_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_group_member_repository {


  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *name;
};

/**
 * Reads a RepositoryGroupMemberRepository from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupMemberRepository, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_group_member_repository *xmlTextReaderReadNs0Repository_group_member_repositoryType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryGroupMemberRepository to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupMemberRepository The RepositoryGroupMemberRepository to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_group_member_repositoryType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_group_member_repository *_repositoryGroupMemberRepository);

/**
 * Frees the elements of a RepositoryGroupMemberRepository.
 *
 * @param _repositoryGroupMemberRepository The RepositoryGroupMemberRepository to free.
 */
static void freeNs0Repository_group_member_repositoryType(struct nexus_rest_api_ns0_repository_group_member_repository *_repositoryGroupMemberRepository);

#endif /* DEF_nexus_rest_api_ns0_repository_group_member_repository_H */
#ifndef DEF_nexus_rest_api_ns0_repository_group_resource_H
#define DEF_nexus_rest_api_ns0_repository_group_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_group_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *provider;

  /**
   * (no documentation provided)
   */
  int exposed;

  /**
   * (no documentation provided)
   */
  xmlChar *repoType;

  /**
   * (no documentation provided)
   */
  xmlChar *format;

  /**
   * (no documentation provided)
   */
  xmlChar *providerRole;

  /**
   * (no documentation provided)
   */
  xmlChar *contentResourceURI;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_group_member_repository *repositories;

  /**
   * Size of the repositories array.
   */
  int _sizeof_repositories;
};

/**
 * Reads a RepositoryGroupResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_group_resource *xmlTextReaderReadNs0Repository_group_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryGroupResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResource The RepositoryGroupResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_group_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_group_resource *_repositoryGroupResource);

/**
 * Frees the elements of a RepositoryGroupResource.
 *
 * @param _repositoryGroupResource The RepositoryGroupResource to free.
 */
static void freeNs0Repository_group_resourceType(struct nexus_rest_api_ns0_repository_group_resource *_repositoryGroupResource);

#endif /* DEF_nexus_rest_api_ns0_repository_group_resource_H */
#ifndef DEF_nexus_rest_api_ns0_repositoryGroupResourceResponse_H
#define DEF_nexus_rest_api_ns0_repositoryGroupResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repositoryGroupResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_group_resource *data;
};

/**
 * Reads a RepositoryGroupResourceResponse element from XML. The element to be read is "repo-group", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryGroupResourceResponse *xml_read_nexus_rest_api_ns0_repositoryGroupResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryGroupResourceResponse to XML under element name "repo-group".
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_repositoryGroupResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse);

/**
 * Frees a RepositoryGroupResourceResponse.
 *
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryGroupResourceResponse(struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse);

/**
 * Reads a RepositoryGroupResourceResponse element from XML. The element to be read is "repo-group", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryGroupResourceResponse *xmlTextReaderReadNs0Repo_groupElement(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryGroupResourceResponse to XML under element name "repo-group".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repo_groupElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse);

/**
 * Writes a RepositoryGroupResourceResponse to XML under element name "repo-group".
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repo_groupElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse, int writeNamespaces);

/**
 * Frees the children of a RepositoryGroupResourceResponse.
 *
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse whose children are to be free.
 */
static void freeNs0Repo_groupElement(struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse);

/**
 * Reads a RepositoryGroupResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryGroupResourceResponse *xmlTextReaderReadNs0RepositoryGroupResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryGroupResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryGroupResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse);

/**
 * Frees the elements of a RepositoryGroupResourceResponse.
 *
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to free.
 */
static void freeNs0RepositoryGroupResourceResponseType(struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_repositoryGroupResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_repositoryResourceResponse_H
#define DEF_nexus_rest_api_ns0_repositoryResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repositoryResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_base_repository *data;
};

/**
 * Reads a RepositoryResourceResponse element from XML. The element to be read is "repository", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryResourceResponse *xml_read_nexus_rest_api_ns0_repositoryResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryResourceResponse to XML under element name "repository".
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_repositoryResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse);

/**
 * Frees a RepositoryResourceResponse.
 *
 * @param _repositoryResourceResponse The RepositoryResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryResourceResponse(struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse);

/**
 * Reads a RepositoryResourceResponse element from XML. The element to be read is "repository", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RepositoryResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryResourceResponse *xmlTextReaderReadNs0RepositoryElement(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryResourceResponse to XML under element name "repository".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse);

/**
 * Writes a RepositoryResourceResponse to XML under element name "repository".
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse, int writeNamespaces);

/**
 * Frees the children of a RepositoryResourceResponse.
 *
 * @param _repositoryResourceResponse The RepositoryResourceResponse whose children are to be free.
 */
static void freeNs0RepositoryElement(struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse);

/**
 * Reads a RepositoryResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryResourceResponse *xmlTextReaderReadNs0RepositoryResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse);

/**
 * Frees the elements of a RepositoryResourceResponse.
 *
 * @param _repositoryResourceResponse The RepositoryResourceResponse to free.
 */
static void freeNs0RepositoryResourceResponseType(struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_repositoryResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_repository_route_member_repo_H
#define DEF_nexus_rest_api_ns0_repository_route_member_repo_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_route_member_repo {


  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *id;
};

/**
 * Reads a RepositoryRouteMemberRepository from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteMemberRepository, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_route_member_repo *xmlTextReaderReadNs0Repository_route_member_repoType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryRouteMemberRepository to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteMemberRepository The RepositoryRouteMemberRepository to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_route_member_repoType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_route_member_repo *_repositoryRouteMemberRepository);

/**
 * Frees the elements of a RepositoryRouteMemberRepository.
 *
 * @param _repositoryRouteMemberRepository The RepositoryRouteMemberRepository to free.
 */
static void freeNs0Repository_route_member_repoType(struct nexus_rest_api_ns0_repository_route_member_repo *_repositoryRouteMemberRepository);

#endif /* DEF_nexus_rest_api_ns0_repository_route_member_repo_H */
#ifndef DEF_nexus_rest_api_ns0_repository_route_resource_H
#define DEF_nexus_rest_api_ns0_repository_route_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_route_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *pattern;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_route_member_repo *repositories;

  /**
   * Size of the repositories array.
   */
  int _sizeof_repositories;

  /**
   * (no documentation provided)
   */
  xmlChar *groupId;

  /**
   * (no documentation provided)
   */
  xmlChar *ruleType;
};

/**
 * Reads a RepositoryRouteResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_route_resource *xmlTextReaderReadNs0Repository_route_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryRouteResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResource The RepositoryRouteResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_route_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_route_resource *_repositoryRouteResource);

/**
 * Frees the elements of a RepositoryRouteResource.
 *
 * @param _repositoryRouteResource The RepositoryRouteResource to free.
 */
static void freeNs0Repository_route_resourceType(struct nexus_rest_api_ns0_repository_route_resource *_repositoryRouteResource);

#endif /* DEF_nexus_rest_api_ns0_repository_route_resource_H */
#ifndef DEF_nexus_rest_api_ns0_repositoryRouteResourceResponse_H
#define DEF_nexus_rest_api_ns0_repositoryRouteResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repositoryRouteResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_route_resource *data;
};

/**
 * Reads a RepositoryRouteResourceResponse element from XML. The element to be read is "repo-route", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryRouteResourceResponse *xml_read_nexus_rest_api_ns0_repositoryRouteResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryRouteResourceResponse to XML under element name "repo-route".
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_repositoryRouteResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse);

/**
 * Frees a RepositoryRouteResourceResponse.
 *
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryRouteResourceResponse(struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse);

/**
 * Reads a RepositoryRouteResourceResponse element from XML. The element to be read is "repo-route", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryRouteResourceResponse *xmlTextReaderReadNs0Repo_routeElement(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryRouteResourceResponse to XML under element name "repo-route".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repo_routeElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse);

/**
 * Writes a RepositoryRouteResourceResponse to XML under element name "repo-route".
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repo_routeElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse, int writeNamespaces);

/**
 * Frees the children of a RepositoryRouteResourceResponse.
 *
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse whose children are to be free.
 */
static void freeNs0Repo_routeElement(struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse);

/**
 * Reads a RepositoryRouteResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryRouteResourceResponse *xmlTextReaderReadNs0RepositoryRouteResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryRouteResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryRouteResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse);

/**
 * Frees the elements of a RepositoryRouteResourceResponse.
 *
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to free.
 */
static void freeNs0RepositoryRouteResourceResponseType(struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_repositoryRouteResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_repository_status_H
#define DEF_nexus_rest_api_ns0_repository_status_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_status {


  /**
   * (no documentation provided)
   */
  xmlChar *format;

  /**
   * (no documentation provided)
   */
  xmlChar *proxyMode;

  /**
   * (no documentation provided)
   */
  xmlChar *repoType;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_dependent_status *dependentRepos;

  /**
   * Size of the dependentRepos array.
   */
  int _sizeof_dependentRepos;

  /**
   * (no documentation provided)
   */
  xmlChar *remoteStatus;

  /**
   * (no documentation provided)
   */
  xmlChar *localStatus;

  /**
   * (no documentation provided)
   */
  xmlChar *id;
};

/**
 * Reads a RepositoryStatusResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryStatusResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_status *xmlTextReaderReadNs0Repository_statusType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryStatusResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResource The RepositoryStatusResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_statusType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_status *_repositoryStatusResource);

/**
 * Frees the elements of a RepositoryStatusResource.
 *
 * @param _repositoryStatusResource The RepositoryStatusResource to free.
 */
static void freeNs0Repository_statusType(struct nexus_rest_api_ns0_repository_status *_repositoryStatusResource);

#endif /* DEF_nexus_rest_api_ns0_repository_status_H */
#ifndef DEF_nexus_rest_api_ns0_repositoryStatusResourceResponse_H
#define DEF_nexus_rest_api_ns0_repositoryStatusResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repositoryStatusResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_status *data;
};

/**
 * Reads a RepositoryStatusResourceResponse element from XML. The element to be read is "repository-status", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryStatusResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryStatusResourceResponse *xml_read_nexus_rest_api_ns0_repositoryStatusResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryStatusResourceResponse to XML under element name "repository-status".
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_repositoryStatusResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse);

/**
 * Frees a RepositoryStatusResourceResponse.
 *
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryStatusResourceResponse(struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse);

/**
 * Reads a RepositoryStatusResourceResponse element from XML. The element to be read is "repository-status", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RepositoryStatusResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryStatusResourceResponse *xmlTextReaderReadNs0Repository_statusElement(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryStatusResourceResponse to XML under element name "repository-status".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_statusElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse);

/**
 * Writes a RepositoryStatusResourceResponse to XML under element name "repository-status".
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_statusElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse, int writeNamespaces);

/**
 * Frees the children of a RepositoryStatusResourceResponse.
 *
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse whose children are to be free.
 */
static void freeNs0Repository_statusElement(struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse);

/**
 * Reads a RepositoryStatusResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryStatusResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryStatusResourceResponse *xmlTextReaderReadNs0RepositoryStatusResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryStatusResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryStatusResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse);

/**
 * Frees the elements of a RepositoryStatusResourceResponse.
 *
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to free.
 */
static void freeNs0RepositoryStatusResourceResponseType(struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_repositoryStatusResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_repository_target_resource_H
#define DEF_nexus_rest_api_ns0_repository_target_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repository_target_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *patterns;

  /**
   * Size of the patterns array.
   */
  int _sizeof_patterns;

  /**
   * (no documentation provided)
   */
  xmlChar *contentClass;
};

/**
 * Reads a RepositoryTargetResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryTargetResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_target_resource *xmlTextReaderReadNs0Repository_target_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryTargetResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResource The RepositoryTargetResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_target_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_target_resource *_repositoryTargetResource);

/**
 * Frees the elements of a RepositoryTargetResource.
 *
 * @param _repositoryTargetResource The RepositoryTargetResource to free.
 */
static void freeNs0Repository_target_resourceType(struct nexus_rest_api_ns0_repository_target_resource *_repositoryTargetResource);

#endif /* DEF_nexus_rest_api_ns0_repository_target_resource_H */
#ifndef DEF_nexus_rest_api_ns0_repositoryTargetResourceResponse_H
#define DEF_nexus_rest_api_ns0_repositoryTargetResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_repositoryTargetResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_repository_target_resource *data;
};

/**
 * Reads a RepositoryTargetResourceResponse element from XML. The element to be read is "repo-target", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryTargetResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryTargetResourceResponse *xml_read_nexus_rest_api_ns0_repositoryTargetResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryTargetResourceResponse to XML under element name "repo-target".
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_repositoryTargetResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse);

/**
 * Frees a RepositoryTargetResourceResponse.
 *
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryTargetResourceResponse(struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse);

/**
 * Reads a RepositoryTargetResourceResponse element from XML. The element to be read is "repo-target", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RepositoryTargetResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryTargetResourceResponse *xmlTextReaderReadNs0Repo_targetElement(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryTargetResourceResponse to XML under element name "repo-target".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repo_targetElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse);

/**
 * Writes a RepositoryTargetResourceResponse to XML under element name "repo-target".
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repo_targetElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse, int writeNamespaces);

/**
 * Frees the children of a RepositoryTargetResourceResponse.
 *
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse whose children are to be free.
 */
static void freeNs0Repo_targetElement(struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse);

/**
 * Reads a RepositoryTargetResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryTargetResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryTargetResourceResponse *xmlTextReaderReadNs0RepositoryTargetResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryTargetResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryTargetResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse);

/**
 * Frees the elements of a RepositoryTargetResourceResponse.
 *
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to free.
 */
static void freeNs0RepositoryTargetResourceResponseType(struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_repositoryTargetResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_rest_api_settings_H
#define DEF_nexus_rest_api_ns0_rest_api_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_rest_api_settings {


  /**
   * (no documentation provided)
   */
  int uiTimeout;

  /**
   * (no documentation provided)
   */
  int forceBaseUrl;

  /**
   * (no documentation provided)
   */
  xmlChar *baseUrl;
};

/**
 * Reads a RestApiSettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RestApiSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_rest_api_settings *xmlTextReaderReadNs0Rest_api_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a RestApiSettings to XML.
 *
 * @param writer The XML writer.
 * @param _restApiSettings The RestApiSettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Rest_api_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_rest_api_settings *_restApiSettings);

/**
 * Frees the elements of a RestApiSettings.
 *
 * @param _restApiSettings The RestApiSettings to free.
 */
static void freeNs0Rest_api_settingsType(struct nexus_rest_api_ns0_rest_api_settings *_restApiSettings);

#endif /* DEF_nexus_rest_api_ns0_rest_api_settings_H */
#ifndef DEF_nexus_rest_api_ns0_scheduled_service_base_resource_H
#define DEF_nexus_rest_api_ns0_scheduled_service_base_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_scheduled_service_base_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *schedule;

  /**
   * (no documentation provided)
   */
  xmlChar *alertEmail;

  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_scheduled_service_property_resource *properties;

  /**
   * Size of the properties array.
   */
  int _sizeof_properties;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  int enabled;

  /**
   * (no documentation provided)
   */
  xmlChar *typeId;
};

/**
 * Reads a ScheduledServiceBaseResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ScheduledServiceBaseResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_scheduled_service_base_resource *xmlTextReaderReadNs0Scheduled_service_base_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a ScheduledServiceBaseResource to XML.
 *
 * @param writer The XML writer.
 * @param _scheduledServiceBaseResource The ScheduledServiceBaseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Scheduled_service_base_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduled_service_base_resource *_scheduledServiceBaseResource);

/**
 * Frees the elements of a ScheduledServiceBaseResource.
 *
 * @param _scheduledServiceBaseResource The ScheduledServiceBaseResource to free.
 */
static void freeNs0Scheduled_service_base_resourceType(struct nexus_rest_api_ns0_scheduled_service_base_resource *_scheduledServiceBaseResource);

#endif /* DEF_nexus_rest_api_ns0_scheduled_service_base_resource_H */
#ifndef DEF_nexus_rest_api_ns0_scheduled_service_property_resource_H
#define DEF_nexus_rest_api_ns0_scheduled_service_property_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_scheduled_service_property_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *key;

  /**
   * (no documentation provided)
   */
  xmlChar *value;
};

/**
 * Reads a ScheduledServicePropertyResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ScheduledServicePropertyResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_scheduled_service_property_resource *xmlTextReaderReadNs0Scheduled_service_property_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a ScheduledServicePropertyResource to XML.
 *
 * @param writer The XML writer.
 * @param _scheduledServicePropertyResource The ScheduledServicePropertyResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Scheduled_service_property_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduled_service_property_resource *_scheduledServicePropertyResource);

/**
 * Frees the elements of a ScheduledServicePropertyResource.
 *
 * @param _scheduledServicePropertyResource The ScheduledServicePropertyResource to free.
 */
static void freeNs0Scheduled_service_property_resourceType(struct nexus_rest_api_ns0_scheduled_service_property_resource *_scheduledServicePropertyResource);

#endif /* DEF_nexus_rest_api_ns0_scheduled_service_property_resource_H */
#ifndef DEF_nexus_rest_api_ns0_scheduledServiceResourceResponse_H
#define DEF_nexus_rest_api_ns0_scheduledServiceResourceResponse_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_scheduledServiceResourceResponse {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_scheduled_service_base_resource *data;
};

/**
 * Reads a ScheduledServiceResourceResponse element from XML. The element to be read is "scheduled-task", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ScheduledServiceResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_scheduledServiceResourceResponse *xml_read_nexus_rest_api_ns0_scheduledServiceResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a ScheduledServiceResourceResponse to XML under element name "scheduled-task".
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_scheduledServiceResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse);

/**
 * Frees a ScheduledServiceResourceResponse.
 *
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to free.
 */
void free_nexus_rest_api_ns0_scheduledServiceResourceResponse(struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse);

/**
 * Reads a ScheduledServiceResourceResponse element from XML. The element to be read is "scheduled-task", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ScheduledServiceResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_scheduledServiceResourceResponse *xmlTextReaderReadNs0Scheduled_taskElement(xmlTextReaderPtr reader);

/**
 * Writes a ScheduledServiceResourceResponse to XML under element name "scheduled-task".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Scheduled_taskElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse);

/**
 * Writes a ScheduledServiceResourceResponse to XML under element name "scheduled-task".
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Scheduled_taskElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse, int writeNamespaces);

/**
 * Frees the children of a ScheduledServiceResourceResponse.
 *
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse whose children are to be free.
 */
static void freeNs0Scheduled_taskElement(struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse);

/**
 * Reads a ScheduledServiceResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ScheduledServiceResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_scheduledServiceResourceResponse *xmlTextReaderReadNs0ScheduledServiceResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a ScheduledServiceResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ScheduledServiceResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse);

/**
 * Frees the elements of a ScheduledServiceResourceResponse.
 *
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to free.
 */
static void freeNs0ScheduledServiceResourceResponseType(struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse);

#endif /* DEF_nexus_rest_api_ns0_scheduledServiceResourceResponse_H */
#ifndef DEF_nexus_rest_api_ns0_smtp_settings_H
#define DEF_nexus_rest_api_ns0_smtp_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_smtp_settings {


  /**
   * (no documentation provided)
   */
  xmlChar *password;

  /**
   * (no documentation provided)
   */
  xmlChar *host;

  /**
   * (no documentation provided)
   */
  xmlChar *systemEmailAddress;

  /**
   * (no documentation provided)
   */
  xmlChar *username;

  /**
   * (no documentation provided)
   */
  int port;

  /**
   * (no documentation provided)
   */
  int tlsEnabled;

  /**
   * (no documentation provided)
   */
  int sslEnabled;
};

/**
 * Reads a SmtpSettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SmtpSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_smtp_settings *xmlTextReaderReadNs0Smtp_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a SmtpSettings to XML.
 *
 * @param writer The XML writer.
 * @param _smtpSettings The SmtpSettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Smtp_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtp_settings *_smtpSettings);

/**
 * Frees the elements of a SmtpSettings.
 *
 * @param _smtpSettings The SmtpSettings to free.
 */
static void freeNs0Smtp_settingsType(struct nexus_rest_api_ns0_smtp_settings *_smtpSettings);

#endif /* DEF_nexus_rest_api_ns0_smtp_settings_H */
#ifndef DEF_nexus_rest_api_ns0_smtp_settings_resource_H
#define DEF_nexus_rest_api_ns0_smtp_settings_resource_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_smtp_settings_resource {


  /**
   * (no documentation provided)
   */
  xmlChar *testEmail;

  /**
   * (no documentation provided)
   */
  xmlChar *host;

  /**
   * (no documentation provided)
   */
  xmlChar *password;

  /**
   * (no documentation provided)
   */
  int tlsEnabled;

  /**
   * (no documentation provided)
   */
  xmlChar *systemEmailAddress;

  /**
   * (no documentation provided)
   */
  int sslEnabled;

  /**
   * (no documentation provided)
   */
  xmlChar *username;

  /**
   * (no documentation provided)
   */
  int port;
};

/**
 * Reads a SmtpSettingsResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SmtpSettingsResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_smtp_settings_resource *xmlTextReaderReadNs0Smtp_settings_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a SmtpSettingsResource to XML.
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResource The SmtpSettingsResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Smtp_settings_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtp_settings_resource *_smtpSettingsResource);

/**
 * Frees the elements of a SmtpSettingsResource.
 *
 * @param _smtpSettingsResource The SmtpSettingsResource to free.
 */
static void freeNs0Smtp_settings_resourceType(struct nexus_rest_api_ns0_smtp_settings_resource *_smtpSettingsResource);

#endif /* DEF_nexus_rest_api_ns0_smtp_settings_resource_H */
#ifndef DEF_nexus_rest_api_ns0_smtpSettingsResourceRequest_H
#define DEF_nexus_rest_api_ns0_smtpSettingsResourceRequest_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_smtpSettingsResourceRequest {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_smtp_settings_resource *data;
};

/**
 * Reads a SmtpSettingsResourceRequest element from XML. The element to be read is "smtp-settings-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SmtpSettingsResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_smtpSettingsResourceRequest *xml_read_nexus_rest_api_ns0_smtpSettingsResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a SmtpSettingsResourceRequest to XML under element name "smtp-settings-request".
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_smtpSettingsResourceRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest);

/**
 * Frees a SmtpSettingsResourceRequest.
 *
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to free.
 */
void free_nexus_rest_api_ns0_smtpSettingsResourceRequest(struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest);

/**
 * Reads a SmtpSettingsResourceRequest element from XML. The element to be read is "smtp-settings-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SmtpSettingsResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_smtpSettingsResourceRequest *xmlTextReaderReadNs0Smtp_settings_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a SmtpSettingsResourceRequest to XML under element name "smtp-settings-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Smtp_settings_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest);

/**
 * Writes a SmtpSettingsResourceRequest to XML under element name "smtp-settings-request".
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Smtp_settings_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest, int writeNamespaces);

/**
 * Frees the children of a SmtpSettingsResourceRequest.
 *
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest whose children are to be free.
 */
static void freeNs0Smtp_settings_requestElement(struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest);

/**
 * Reads a SmtpSettingsResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SmtpSettingsResourceRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_smtpSettingsResourceRequest *xmlTextReaderReadNs0SmtpSettingsResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a SmtpSettingsResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SmtpSettingsResourceRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest);

/**
 * Frees the elements of a SmtpSettingsResourceRequest.
 *
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to free.
 */
static void freeNs0SmtpSettingsResourceRequestType(struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest);

#endif /* DEF_nexus_rest_api_ns0_smtpSettingsResourceRequest_H */
#ifndef DEF_nexus_rest_api_ns0_system_notification_settings_H
#define DEF_nexus_rest_api_ns0_system_notification_settings_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_system_notification_settings {


  /**
   * (no documentation provided)
   */
  xmlChar *roles;

  /**
   * Size of the roles array.
   */
  int _sizeof_roles;

  /**
   * (no documentation provided)
   */
  xmlChar *emailAddresses;

  /**
   * (no documentation provided)
   */
  int enabled;
};

/**
 * Reads a SystemNotificationSettings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SystemNotificationSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_system_notification_settings *xmlTextReaderReadNs0System_notification_settingsType(xmlTextReaderPtr reader);

/**
 * Writes a SystemNotificationSettings to XML.
 *
 * @param writer The XML writer.
 * @param _systemNotificationSettings The SystemNotificationSettings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0System_notification_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_system_notification_settings *_systemNotificationSettings);

/**
 * Frees the elements of a SystemNotificationSettings.
 *
 * @param _systemNotificationSettings The SystemNotificationSettings to free.
 */
static void freeNs0System_notification_settingsType(struct nexus_rest_api_ns0_system_notification_settings *_systemNotificationSettings);

#endif /* DEF_nexus_rest_api_ns0_system_notification_settings_H */
#ifndef DEF_nexus_rest_api_ns0_userAccount_H
#define DEF_nexus_rest_api_ns0_userAccount_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_userAccount {


  /**
   * (no documentation provided)
   */
  xmlChar *firstName;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *lastName;

  /**
   * (no documentation provided)
   */
  xmlChar *email;
};

/**
 * Reads a UserAccount from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccount, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_userAccount *xmlTextReaderReadNs0UserAccountType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccount to XML.
 *
 * @param writer The XML writer.
 * @param _userAccount The UserAccount to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccount *_userAccount);

/**
 * Frees the elements of a UserAccount.
 *
 * @param _userAccount The UserAccount to free.
 */
static void freeNs0UserAccountType(struct nexus_rest_api_ns0_userAccount *_userAccount);

#endif /* DEF_nexus_rest_api_ns0_userAccount_H */
#ifndef DEF_nexus_rest_api_ns0_userAccountRequestResponseWrapper_H
#define DEF_nexus_rest_api_ns0_userAccountRequestResponseWrapper_H

/**
 * (no documentation provided)
 */
struct nexus_rest_api_ns0_userAccountRequestResponseWrapper {


  /**
   * (no documentation provided)
   */
  struct nexus_rest_api_ns0_userAccount *data;
};

/**
 * Reads a UserAccountRequestResponseWrapper element from XML. The element to be read is "user-account-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountRequestResponseWrapper, or NULL in case of error.
 */
struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *xml_read_nexus_rest_api_ns0_userAccountRequestResponseWrapper(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountRequestResponseWrapper to XML under element name "user-account-request".
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_rest_api_ns0_userAccountRequestResponseWrapper(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper);

/**
 * Frees a UserAccountRequestResponseWrapper.
 *
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to free.
 */
void free_nexus_rest_api_ns0_userAccountRequestResponseWrapper(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper);

/**
 * Reads a UserAccountRequestResponseWrapper element from XML. The element to be read is "user-account-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserAccountRequestResponseWrapper, or NULL in case of error.
 */
struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *xmlTextReaderReadNs0User_account_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountRequestResponseWrapper to XML under element name "user-account-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_account_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper);

/**
 * Writes a UserAccountRequestResponseWrapper to XML under element name "user-account-request".
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_account_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper, int writeNamespaces);

/**
 * Frees the children of a UserAccountRequestResponseWrapper.
 *
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper whose children are to be free.
 */
static void freeNs0User_account_requestElement(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper);

/**
 * Reads a UserAccountRequestResponseWrapper from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccountRequestResponseWrapper, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *xmlTextReaderReadNs0UserAccountRequestResponseWrapperType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountRequestResponseWrapper to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountRequestResponseWrapperType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper);

/**
 * Frees the elements of a UserAccountRequestResponseWrapper.
 *
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to free.
 */
static void freeNs0UserAccountRequestResponseWrapperType(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper);

#endif /* DEF_nexus_rest_api_ns0_userAccountRequestResponseWrapper_H */
#ifndef DEF_nexus_rest_api_ns0_authentication_settings_M
#define DEF_nexus_rest_api_ns0_authentication_settings_M

/**
 * Reads a AuthenticationSettings from XML. The reader is assumed to be at the start element.
 *
 * @return the AuthenticationSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_authentication_settings *xmlTextReaderReadNs0Authentication_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_authentication_settings *_authenticationSettings = calloc(1, sizeof(struct nexus_rest_api_ns0_authentication_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Authentication_settingsType(_authenticationSettings);
        free(_authenticationSettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "password", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Authentication_settingsType(_authenticationSettings);
          free(_authenticationSettings);
          return NULL;
        }

        _authenticationSettings->password = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "username", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Authentication_settingsType(_authenticationSettings);
          free(_authenticationSettings);
          return NULL;
        }

        _authenticationSettings->username = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ntlmDomain", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ntlmDomain of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ntlmDomain of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Authentication_settingsType(_authenticationSettings);
          free(_authenticationSettings);
          return NULL;
        }

        _authenticationSettings->ntlmDomain = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ntlmHost", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ntlmHost of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ntlmHost of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Authentication_settingsType(_authenticationSettings);
          free(_authenticationSettings);
          return NULL;
        }

        _authenticationSettings->ntlmHost = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}authentication-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}authentication-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _authenticationSettings;
}

/**
 * Writes a AuthenticationSettings to XML.
 *
 * @param writer The XML writer.
 * @param _authenticationSettings The AuthenticationSettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Authentication_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_authentication_settings *_authenticationSettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_authenticationSettings->password != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "password", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}password...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_authenticationSettings->password));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_authenticationSettings->username != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "username", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}username...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_authenticationSettings->username));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_authenticationSettings->ntlmDomain != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ntlmDomain", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ntlmDomain. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ntlmDomain...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_authenticationSettings->ntlmDomain));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ntlmDomain. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ntlmDomain. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_authenticationSettings->ntlmHost != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ntlmHost", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ntlmHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ntlmHost...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_authenticationSettings->ntlmHost));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ntlmHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ntlmHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a AuthenticationSettings.
 *
 * @param _authenticationSettings The AuthenticationSettings to free.
 */
static void freeNs0Authentication_settingsType(struct nexus_rest_api_ns0_authentication_settings *_authenticationSettings) {
  int i;
  if (_authenticationSettings->password != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor password of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    freeXsStringType(_authenticationSettings->password);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor password of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    free(_authenticationSettings->password);
  }
  if (_authenticationSettings->username != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor username of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    freeXsStringType(_authenticationSettings->username);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor username of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    free(_authenticationSettings->username);
  }
  if (_authenticationSettings->ntlmDomain != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ntlmDomain of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    freeXsStringType(_authenticationSettings->ntlmDomain);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ntlmDomain of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    free(_authenticationSettings->ntlmDomain);
  }
  if (_authenticationSettings->ntlmHost != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ntlmHost of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    freeXsStringType(_authenticationSettings->ntlmHost);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ntlmHost of type nexus_rest_api_ns0_authentication_settings...\n");
#endif
    free(_authenticationSettings->ntlmHost);
  }
}
#endif /* DEF_nexus_rest_api_ns0_authentication_settings_M */
#ifndef DEF_nexus_rest_api_ns0_errorReportRequest_M
#define DEF_nexus_rest_api_ns0_errorReportRequest_M

/**
 * Reads a ErrorReportRequest element from XML. The element to be read is "error-report-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ErrorReportRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_errorReportRequest *xml_read_nexus_rest_api_ns0_errorReportRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Error_report_requestElement(reader);
}

/**
 * Writes a ErrorReportRequest to XML under element name "error-report-request".
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_errorReportRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest) {
  return xmlTextWriterWriteNs0Error_report_requestElementNS(writer, _errorReportRequest, 1);
}

/**
 * Frees a ErrorReportRequest.
 *
 * @param _errorReportRequest The ErrorReportRequest to free.
 */
void free_nexus_rest_api_ns0_errorReportRequest(struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest) {
  freeNs0ErrorReportRequestType(_errorReportRequest);
  free(_errorReportRequest);
}

/**
 * Reads a ErrorReportRequest element from XML. The element to be read is "error-report-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ErrorReportRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_errorReportRequest *xmlTextReaderReadNs0Error_report_requestElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "error-report-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}error-report-request.\n");
#endif
    _errorReportRequest = xmlTextReaderReadNs0ErrorReportRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_errorReportRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}error-report-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}error-report-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _errorReportRequest;
}

/**
 * Writes a ErrorReportRequest to XML under element name "error-report-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Error_report_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest) {
  return xmlTextWriterWriteNs0Error_report_requestElementNS(writer, _errorReportRequest, 0);
}

/**
 * Writes a ErrorReportRequest to XML under element name "error-report-request".
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Error_report_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "error-report-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}error-report-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}errorReportRequest for root element {}error-report-request...\n");
#endif
  status = xmlTextWriterWriteNs0ErrorReportRequestType(writer, _errorReportRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}error-report-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}error-report-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ErrorReportRequest.
 *
 * @param _errorReportRequest The ErrorReportRequest whose children are to be free.
 */
static void freeNs0Error_report_requestElement(struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest) {
  freeNs0ErrorReportRequestType(_errorReportRequest);
}

/**
 * Reads a ErrorReportRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the ErrorReportRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_errorReportRequest *xmlTextReaderReadNs0ErrorReportRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest = calloc(1, sizeof(struct nexus_rest_api_ns0_errorReportRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ErrorReportRequestType(_errorReportRequest);
        free(_errorReportRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}error-report-request-dto.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Error_report_request_dtoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}error-report-request-dto.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ErrorReportRequestType(_errorReportRequest);
          free(_errorReportRequest);
          return NULL;
        }

        _errorReportRequest->data = ((struct nexus_rest_api_ns0_error_report_request_dto*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}errorReportRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}errorReportRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _errorReportRequest;
}

/**
 * Writes a ErrorReportRequest to XML.
 *
 * @param writer The XML writer.
 * @param _errorReportRequest The ErrorReportRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ErrorReportRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_errorReportRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}error-report-request-dto for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Error_report_request_dtoType(writer, (_errorReportRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}error-report-request-dto for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ErrorReportRequest.
 *
 * @param _errorReportRequest The ErrorReportRequest to free.
 */
static void freeNs0ErrorReportRequestType(struct nexus_rest_api_ns0_errorReportRequest *_errorReportRequest) {
  int i;
  if (_errorReportRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_errorReportRequest...\n");
#endif
    freeNs0Error_report_request_dtoType(_errorReportRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_errorReportRequest...\n");
#endif
    free(_errorReportRequest->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_errorReportRequest_M */
#ifndef DEF_nexus_rest_api_ns0_error_report_request_dto_M
#define DEF_nexus_rest_api_ns0_error_report_request_dto_M

/**
 * Reads a ErrorReportRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ErrorReportRequestDTO, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_error_report_request_dto *xmlTextReaderReadNs0Error_report_request_dtoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_error_report_request_dto *_errorReportRequestDTO = calloc(1, sizeof(struct nexus_rest_api_ns0_error_report_request_dto));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Error_report_request_dtoType(_errorReportRequestDTO);
        free(_errorReportRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_report_request_dtoType(_errorReportRequestDTO);
          free(_errorReportRequestDTO);
          return NULL;
        }

        _errorReportRequestDTO->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "title", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}title of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}title of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_report_request_dtoType(_errorReportRequestDTO);
          free(_errorReportRequestDTO);
          return NULL;
        }

        _errorReportRequestDTO->title = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "saveErrorReportingSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}saveErrorReportingSettings of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}saveErrorReportingSettings of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_report_request_dtoType(_errorReportRequestDTO);
          free(_errorReportRequestDTO);
          return NULL;
        }

        _errorReportRequestDTO->saveErrorReportingSettings = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "errorReportingSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}errorReportingSettings of type {}error-reporting-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Error_reporting_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}errorReportingSettings of type {}error-reporting-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_report_request_dtoType(_errorReportRequestDTO);
          free(_errorReportRequestDTO);
          return NULL;
        }

        _errorReportRequestDTO->errorReportingSettings = ((struct nexus_rest_api_ns0_error_reporting_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}error-report-request-dto.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}error-report-request-dto. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _errorReportRequestDTO;
}

/**
 * Writes a ErrorReportRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _errorReportRequestDTO The ErrorReportRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Error_report_request_dtoType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_error_report_request_dto *_errorReportRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_errorReportRequestDTO->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_errorReportRequestDTO->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_errorReportRequestDTO->title != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "title", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}title. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}title...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_errorReportRequestDTO->title));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}title. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}title. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "saveErrorReportingSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}saveErrorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}saveErrorReportingSettings...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_errorReportRequestDTO->saveErrorReportingSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}saveErrorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}saveErrorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_errorReportRequestDTO->errorReportingSettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "errorReportingSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}errorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}error-reporting-settings for element {}errorReportingSettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0Error_reporting_settingsType(writer, (_errorReportRequestDTO->errorReportingSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}error-reporting-settings for element {}errorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}errorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ErrorReportRequestDTO.
 *
 * @param _errorReportRequestDTO The ErrorReportRequestDTO to free.
 */
static void freeNs0Error_report_request_dtoType(struct nexus_rest_api_ns0_error_report_request_dto *_errorReportRequestDTO) {
  int i;
  if (_errorReportRequestDTO->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_rest_api_ns0_error_report_request_dto...\n");
#endif
    freeXsStringType(_errorReportRequestDTO->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_rest_api_ns0_error_report_request_dto...\n");
#endif
    free(_errorReportRequestDTO->description);
  }
  if (_errorReportRequestDTO->title != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor title of type nexus_rest_api_ns0_error_report_request_dto...\n");
#endif
    freeXsStringType(_errorReportRequestDTO->title);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor title of type nexus_rest_api_ns0_error_report_request_dto...\n");
#endif
    free(_errorReportRequestDTO->title);
  }
  if (_errorReportRequestDTO->errorReportingSettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor errorReportingSettings of type nexus_rest_api_ns0_error_report_request_dto...\n");
#endif
    freeNs0Error_reporting_settingsType(_errorReportRequestDTO->errorReportingSettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor errorReportingSettings of type nexus_rest_api_ns0_error_report_request_dto...\n");
#endif
    free(_errorReportRequestDTO->errorReportingSettings);
  }
}
#endif /* DEF_nexus_rest_api_ns0_error_report_request_dto_M */
#ifndef DEF_nexus_rest_api_ns0_error_reporting_settings_M
#define DEF_nexus_rest_api_ns0_error_reporting_settings_M

/**
 * Reads a ErrorReportingSettings from XML. The reader is assumed to be at the start element.
 *
 * @return the ErrorReportingSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_error_reporting_settings *xmlTextReaderReadNs0Error_reporting_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_error_reporting_settings *_errorReportingSettings = calloc(1, sizeof(struct nexus_rest_api_ns0_error_reporting_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Error_reporting_settingsType(_errorReportingSettings);
        free(_errorReportingSettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "jiraUsername", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}jiraUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}jiraUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_reporting_settingsType(_errorReportingSettings);
          free(_errorReportingSettings);
          return NULL;
        }

        _errorReportingSettings->jiraUsername = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "reportErrorsAutomatically", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}reportErrorsAutomatically of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}reportErrorsAutomatically of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_reporting_settingsType(_errorReportingSettings);
          free(_errorReportingSettings);
          return NULL;
        }

        _errorReportingSettings->reportErrorsAutomatically = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "useGlobalProxy", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}useGlobalProxy of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}useGlobalProxy of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_reporting_settingsType(_errorReportingSettings);
          free(_errorReportingSettings);
          return NULL;
        }

        _errorReportingSettings->useGlobalProxy = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "jiraPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}jiraPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}jiraPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Error_reporting_settingsType(_errorReportingSettings);
          free(_errorReportingSettings);
          return NULL;
        }

        _errorReportingSettings->jiraPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}error-reporting-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}error-reporting-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _errorReportingSettings;
}

/**
 * Writes a ErrorReportingSettings to XML.
 *
 * @param writer The XML writer.
 * @param _errorReportingSettings The ErrorReportingSettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Error_reporting_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_error_reporting_settings *_errorReportingSettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_errorReportingSettings->jiraUsername != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "jiraUsername", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}jiraUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}jiraUsername...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_errorReportingSettings->jiraUsername));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}jiraUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}jiraUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "reportErrorsAutomatically", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}reportErrorsAutomatically. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}reportErrorsAutomatically...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_errorReportingSettings->reportErrorsAutomatically));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}reportErrorsAutomatically. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}reportErrorsAutomatically. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "useGlobalProxy", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}useGlobalProxy. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}useGlobalProxy...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_errorReportingSettings->useGlobalProxy));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}useGlobalProxy. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}useGlobalProxy. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_errorReportingSettings->jiraPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "jiraPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}jiraPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}jiraPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_errorReportingSettings->jiraPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}jiraPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}jiraPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ErrorReportingSettings.
 *
 * @param _errorReportingSettings The ErrorReportingSettings to free.
 */
static void freeNs0Error_reporting_settingsType(struct nexus_rest_api_ns0_error_reporting_settings *_errorReportingSettings) {
  int i;
  if (_errorReportingSettings->jiraUsername != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor jiraUsername of type nexus_rest_api_ns0_error_reporting_settings...\n");
#endif
    freeXsStringType(_errorReportingSettings->jiraUsername);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor jiraUsername of type nexus_rest_api_ns0_error_reporting_settings...\n");
#endif
    free(_errorReportingSettings->jiraUsername);
  }
  if (_errorReportingSettings->jiraPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor jiraPassword of type nexus_rest_api_ns0_error_reporting_settings...\n");
#endif
    freeXsStringType(_errorReportingSettings->jiraPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor jiraPassword of type nexus_rest_api_ns0_error_reporting_settings...\n");
#endif
    free(_errorReportingSettings->jiraPassword);
  }
}
#endif /* DEF_nexus_rest_api_ns0_error_reporting_settings_M */
#ifndef DEF_nexus_rest_api_ns0_global_settings_item_M
#define DEF_nexus_rest_api_ns0_global_settings_item_M

/**
 * Reads a GlobalConfigurationResource from XML. The reader is assumed to be at the start element.
 *
 * @return the GlobalConfigurationResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_global_settings_item *xmlTextReaderReadNs0Global_settings_itemType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_global_settings_item *_globalConfigurationResource = calloc(1, sizeof(struct nexus_rest_api_ns0_global_settings_item));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Global_settings_itemType(_globalConfigurationResource);
        free(_globalConfigurationResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "securityEnabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}securityEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}securityEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->securityEnabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "globalConnectionSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}globalConnectionSettings of type {}remote-connection-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Remote_connection_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}globalConnectionSettings of type {}remote-connection-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->globalConnectionSettings = ((struct nexus_rest_api_ns0_remote_connection_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "globalHttpProxySettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}globalHttpProxySettings of type {}remote-http-proxy-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Remote_http_proxy_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}globalHttpProxySettings of type {}remote-http-proxy-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->globalHttpProxySettings = ((struct nexus_rest_api_ns0_remote_http_proxy_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "securityRealms", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}securityRealms...\n");
#endif
          //start wrapper element "{}securityRealms"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Global_settings_itemType(_globalConfigurationResource);
              free(_globalConfigurationResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "securityRealmItem", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}securityRealmItem of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}securityRealmItem of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->securityRealms = realloc(_globalConfigurationResource->securityRealms, (_globalConfigurationResource->_sizeof_securityRealms + 1) * sizeof(xmlChar));
        memcpy(&(_globalConfigurationResource->securityRealms[_globalConfigurationResource->_sizeof_securityRealms++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}securityRealms.\n");
#endif
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }
        else {
          //end wrapper element "{}securityRealms"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "securityAnonymousUsername", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}securityAnonymousUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}securityAnonymousUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->securityAnonymousUsername = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "smtpSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}smtpSettings of type {}smtp-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Smtp_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}smtpSettings of type {}smtp-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->smtpSettings = ((struct nexus_rest_api_ns0_smtp_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "securityAnonymousPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}securityAnonymousPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}securityAnonymousPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->securityAnonymousPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "globalRestApiSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}globalRestApiSettings of type {}rest-api-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Rest_api_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}globalRestApiSettings of type {}rest-api-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->globalRestApiSettings = ((struct nexus_rest_api_ns0_rest_api_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "errorReportingSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}errorReportingSettings of type {}error-reporting-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Error_reporting_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}errorReportingSettings of type {}error-reporting-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->errorReportingSettings = ((struct nexus_rest_api_ns0_error_reporting_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "securityAnonymousAccessEnabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}securityAnonymousAccessEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}securityAnonymousAccessEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->securityAnonymousAccessEnabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "systemNotificationSettings", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}systemNotificationSettings of type {}system-notification-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0System_notification_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}systemNotificationSettings of type {}system-notification-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Global_settings_itemType(_globalConfigurationResource);
          free(_globalConfigurationResource);
          return NULL;
        }

        _globalConfigurationResource->systemNotificationSettings = ((struct nexus_rest_api_ns0_system_notification_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}global-settings-item.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}global-settings-item. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _globalConfigurationResource;
}

/**
 * Writes a GlobalConfigurationResource to XML.
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResource The GlobalConfigurationResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Global_settings_itemType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_global_settings_item *_globalConfigurationResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "securityEnabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}securityEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}securityEnabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_globalConfigurationResource->securityEnabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}securityEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}securityEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->globalConnectionSettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "globalConnectionSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}globalConnectionSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}remote-connection-settings for element {}globalConnectionSettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0Remote_connection_settingsType(writer, (_globalConfigurationResource->globalConnectionSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}remote-connection-settings for element {}globalConnectionSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}globalConnectionSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->globalHttpProxySettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "globalHttpProxySettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}globalHttpProxySettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}remote-http-proxy-settings for element {}globalHttpProxySettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0Remote_http_proxy_settingsType(writer, (_globalConfigurationResource->globalHttpProxySettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}remote-http-proxy-settings for element {}globalHttpProxySettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}globalHttpProxySettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_globalConfigurationResource->securityRealms != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "securityRealms", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}securityRealms. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _globalConfigurationResource->_sizeof_securityRealms; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "securityRealmItem", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}securityRealmItem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}securityRealmItem...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_globalConfigurationResource->securityRealms[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}securityRealmItem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}securityRealmItem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_globalConfigurationResource->securityRealms != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}securityRealms. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->securityAnonymousUsername != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "securityAnonymousUsername", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}securityAnonymousUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}securityAnonymousUsername...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_globalConfigurationResource->securityAnonymousUsername));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}securityAnonymousUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}securityAnonymousUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->smtpSettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "smtpSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}smtpSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}smtp-settings for element {}smtpSettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0Smtp_settingsType(writer, (_globalConfigurationResource->smtpSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}smtp-settings for element {}smtpSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}smtpSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->securityAnonymousPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "securityAnonymousPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}securityAnonymousPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}securityAnonymousPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_globalConfigurationResource->securityAnonymousPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}securityAnonymousPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}securityAnonymousPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->globalRestApiSettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "globalRestApiSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}globalRestApiSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}rest-api-settings for element {}globalRestApiSettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0Rest_api_settingsType(writer, (_globalConfigurationResource->globalRestApiSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}rest-api-settings for element {}globalRestApiSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}globalRestApiSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->errorReportingSettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "errorReportingSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}errorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}error-reporting-settings for element {}errorReportingSettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0Error_reporting_settingsType(writer, (_globalConfigurationResource->errorReportingSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}error-reporting-settings for element {}errorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}errorReportingSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "securityAnonymousAccessEnabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}securityAnonymousAccessEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}securityAnonymousAccessEnabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_globalConfigurationResource->securityAnonymousAccessEnabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}securityAnonymousAccessEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}securityAnonymousAccessEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_globalConfigurationResource->systemNotificationSettings != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "systemNotificationSettings", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}systemNotificationSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}system-notification-settings for element {}systemNotificationSettings...\n", status);
#endif
    status = xmlTextWriterWriteNs0System_notification_settingsType(writer, (_globalConfigurationResource->systemNotificationSettings));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}system-notification-settings for element {}systemNotificationSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}systemNotificationSettings. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a GlobalConfigurationResource.
 *
 * @param _globalConfigurationResource The GlobalConfigurationResource to free.
 */
static void freeNs0Global_settings_itemType(struct nexus_rest_api_ns0_global_settings_item *_globalConfigurationResource) {
  int i;
  if (_globalConfigurationResource->globalConnectionSettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor globalConnectionSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeNs0Remote_connection_settingsType(_globalConfigurationResource->globalConnectionSettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor globalConnectionSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->globalConnectionSettings);
  }
  if (_globalConfigurationResource->globalHttpProxySettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor globalHttpProxySettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeNs0Remote_http_proxy_settingsType(_globalConfigurationResource->globalHttpProxySettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor globalHttpProxySettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->globalHttpProxySettings);
  }
  if (_globalConfigurationResource->securityRealms != NULL) {
    for (i = 0; i < _globalConfigurationResource->_sizeof_securityRealms; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor securityRealms[%i] of type nexus_rest_api_ns0_global_settings_item...\n", i);
#endif
      freeXsStringType(&(_globalConfigurationResource->securityRealms[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor securityRealms of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->securityRealms);
  }
  if (_globalConfigurationResource->securityAnonymousUsername != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor securityAnonymousUsername of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeXsStringType(_globalConfigurationResource->securityAnonymousUsername);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor securityAnonymousUsername of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->securityAnonymousUsername);
  }
  if (_globalConfigurationResource->smtpSettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor smtpSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeNs0Smtp_settingsType(_globalConfigurationResource->smtpSettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor smtpSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->smtpSettings);
  }
  if (_globalConfigurationResource->securityAnonymousPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor securityAnonymousPassword of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeXsStringType(_globalConfigurationResource->securityAnonymousPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor securityAnonymousPassword of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->securityAnonymousPassword);
  }
  if (_globalConfigurationResource->globalRestApiSettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor globalRestApiSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeNs0Rest_api_settingsType(_globalConfigurationResource->globalRestApiSettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor globalRestApiSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->globalRestApiSettings);
  }
  if (_globalConfigurationResource->errorReportingSettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor errorReportingSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeNs0Error_reporting_settingsType(_globalConfigurationResource->errorReportingSettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor errorReportingSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->errorReportingSettings);
  }
  if (_globalConfigurationResource->systemNotificationSettings != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor systemNotificationSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    freeNs0System_notification_settingsType(_globalConfigurationResource->systemNotificationSettings);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor systemNotificationSettings of type nexus_rest_api_ns0_global_settings_item...\n");
#endif
    free(_globalConfigurationResource->systemNotificationSettings);
  }
}
#endif /* DEF_nexus_rest_api_ns0_global_settings_item_M */
#ifndef DEF_nexus_rest_api_ns0_globalConfigurationResourceResponse_M
#define DEF_nexus_rest_api_ns0_globalConfigurationResourceResponse_M

/**
 * Reads a GlobalConfigurationResourceResponse element from XML. The element to be read is "global-settings", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The GlobalConfigurationResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_globalConfigurationResourceResponse *xml_read_nexus_rest_api_ns0_globalConfigurationResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Global_settingsElement(reader);
}

/**
 * Writes a GlobalConfigurationResourceResponse to XML under element name "global-settings".
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_globalConfigurationResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse) {
  return xmlTextWriterWriteNs0Global_settingsElementNS(writer, _globalConfigurationResourceResponse, 1);
}

/**
 * Frees a GlobalConfigurationResourceResponse.
 *
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to free.
 */
void free_nexus_rest_api_ns0_globalConfigurationResourceResponse(struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse) {
  freeNs0GlobalConfigurationResourceResponseType(_globalConfigurationResourceResponse);
  free(_globalConfigurationResourceResponse);
}

/**
 * Reads a GlobalConfigurationResourceResponse element from XML. The element to be read is "global-settings", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The GlobalConfigurationResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_globalConfigurationResourceResponse *xmlTextReaderReadNs0Global_settingsElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "global-settings", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}global-settings.\n");
#endif
    _globalConfigurationResourceResponse = xmlTextReaderReadNs0GlobalConfigurationResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_globalConfigurationResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}global-settings failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}global-settings failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _globalConfigurationResourceResponse;
}

/**
 * Writes a GlobalConfigurationResourceResponse to XML under element name "global-settings".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Global_settingsElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse) {
  return xmlTextWriterWriteNs0Global_settingsElementNS(writer, _globalConfigurationResourceResponse, 0);
}

/**
 * Writes a GlobalConfigurationResourceResponse to XML under element name "global-settings".
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Global_settingsElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "global-settings", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}global-settings. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}globalConfigurationResourceResponse for root element {}global-settings...\n");
#endif
  status = xmlTextWriterWriteNs0GlobalConfigurationResourceResponseType(writer, _globalConfigurationResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}global-settings. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}global-settings. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a GlobalConfigurationResourceResponse.
 *
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse whose children are to be free.
 */
static void freeNs0Global_settingsElement(struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse) {
  freeNs0GlobalConfigurationResourceResponseType(_globalConfigurationResourceResponse);
}

/**
 * Reads a GlobalConfigurationResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the GlobalConfigurationResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_globalConfigurationResourceResponse *xmlTextReaderReadNs0GlobalConfigurationResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_globalConfigurationResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0GlobalConfigurationResourceResponseType(_globalConfigurationResourceResponse);
        free(_globalConfigurationResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}global-settings-item.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Global_settings_itemType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}global-settings-item.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0GlobalConfigurationResourceResponseType(_globalConfigurationResourceResponse);
          free(_globalConfigurationResourceResponse);
          return NULL;
        }

        _globalConfigurationResourceResponse->data = ((struct nexus_rest_api_ns0_global_settings_item*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}globalConfigurationResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}globalConfigurationResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _globalConfigurationResourceResponse;
}

/**
 * Writes a GlobalConfigurationResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0GlobalConfigurationResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_globalConfigurationResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}global-settings-item for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Global_settings_itemType(writer, (_globalConfigurationResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}global-settings-item for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a GlobalConfigurationResourceResponse.
 *
 * @param _globalConfigurationResourceResponse The GlobalConfigurationResourceResponse to free.
 */
static void freeNs0GlobalConfigurationResourceResponseType(struct nexus_rest_api_ns0_globalConfigurationResourceResponse *_globalConfigurationResourceResponse) {
  int i;
  if (_globalConfigurationResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_globalConfigurationResourceResponse...\n");
#endif
    freeNs0Global_settings_itemType(_globalConfigurationResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_globalConfigurationResourceResponse...\n");
#endif
    free(_globalConfigurationResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_globalConfigurationResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_log_config_resource_M
#define DEF_nexus_rest_api_ns0_log_config_resource_M

/**
 * Reads a LogConfigResource from XML. The reader is assumed to be at the start element.
 *
 * @return the LogConfigResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_log_config_resource *xmlTextReaderReadNs0Log_config_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_log_config_resource *_logConfigResource = calloc(1, sizeof(struct nexus_rest_api_ns0_log_config_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Log_config_resourceType(_logConfigResource);
        free(_logConfigResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "rootLoggerAppenders", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}rootLoggerAppenders of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}rootLoggerAppenders of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Log_config_resourceType(_logConfigResource);
          free(_logConfigResource);
          return NULL;
        }

        _logConfigResource->rootLoggerAppenders = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "fileAppenderLocation", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}fileAppenderLocation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}fileAppenderLocation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Log_config_resourceType(_logConfigResource);
          free(_logConfigResource);
          return NULL;
        }

        _logConfigResource->fileAppenderLocation = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "fileAppenderPattern", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}fileAppenderPattern of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}fileAppenderPattern of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Log_config_resourceType(_logConfigResource);
          free(_logConfigResource);
          return NULL;
        }

        _logConfigResource->fileAppenderPattern = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "rootLoggerLevel", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}rootLoggerLevel of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}rootLoggerLevel of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Log_config_resourceType(_logConfigResource);
          free(_logConfigResource);
          return NULL;
        }

        _logConfigResource->rootLoggerLevel = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}log-config-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}log-config-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _logConfigResource;
}

/**
 * Writes a LogConfigResource to XML.
 *
 * @param writer The XML writer.
 * @param _logConfigResource The LogConfigResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Log_config_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_log_config_resource *_logConfigResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_logConfigResource->rootLoggerAppenders != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "rootLoggerAppenders", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}rootLoggerAppenders. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}rootLoggerAppenders...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_logConfigResource->rootLoggerAppenders));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}rootLoggerAppenders. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}rootLoggerAppenders. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_logConfigResource->fileAppenderLocation != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "fileAppenderLocation", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}fileAppenderLocation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}fileAppenderLocation...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_logConfigResource->fileAppenderLocation));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}fileAppenderLocation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}fileAppenderLocation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_logConfigResource->fileAppenderPattern != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "fileAppenderPattern", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}fileAppenderPattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}fileAppenderPattern...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_logConfigResource->fileAppenderPattern));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}fileAppenderPattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}fileAppenderPattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_logConfigResource->rootLoggerLevel != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "rootLoggerLevel", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}rootLoggerLevel. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}rootLoggerLevel...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_logConfigResource->rootLoggerLevel));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}rootLoggerLevel. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}rootLoggerLevel. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LogConfigResource.
 *
 * @param _logConfigResource The LogConfigResource to free.
 */
static void freeNs0Log_config_resourceType(struct nexus_rest_api_ns0_log_config_resource *_logConfigResource) {
  int i;
  if (_logConfigResource->rootLoggerAppenders != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor rootLoggerAppenders of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    freeXsStringType(_logConfigResource->rootLoggerAppenders);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor rootLoggerAppenders of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    free(_logConfigResource->rootLoggerAppenders);
  }
  if (_logConfigResource->fileAppenderLocation != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor fileAppenderLocation of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    freeXsStringType(_logConfigResource->fileAppenderLocation);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor fileAppenderLocation of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    free(_logConfigResource->fileAppenderLocation);
  }
  if (_logConfigResource->fileAppenderPattern != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor fileAppenderPattern of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    freeXsStringType(_logConfigResource->fileAppenderPattern);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor fileAppenderPattern of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    free(_logConfigResource->fileAppenderPattern);
  }
  if (_logConfigResource->rootLoggerLevel != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor rootLoggerLevel of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    freeXsStringType(_logConfigResource->rootLoggerLevel);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor rootLoggerLevel of type nexus_rest_api_ns0_log_config_resource...\n");
#endif
    free(_logConfigResource->rootLoggerLevel);
  }
}
#endif /* DEF_nexus_rest_api_ns0_log_config_resource_M */
#ifndef DEF_nexus_rest_api_ns0_logConfigResourceResponse_M
#define DEF_nexus_rest_api_ns0_logConfigResourceResponse_M

/**
 * Reads a LogConfigResourceResponse element from XML. The element to be read is "log-config", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LogConfigResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_logConfigResourceResponse *xml_read_nexus_rest_api_ns0_logConfigResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Log_configElement(reader);
}

/**
 * Writes a LogConfigResourceResponse to XML under element name "log-config".
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_logConfigResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse) {
  return xmlTextWriterWriteNs0Log_configElementNS(writer, _logConfigResourceResponse, 1);
}

/**
 * Frees a LogConfigResourceResponse.
 *
 * @param _logConfigResourceResponse The LogConfigResourceResponse to free.
 */
void free_nexus_rest_api_ns0_logConfigResourceResponse(struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse) {
  freeNs0LogConfigResourceResponseType(_logConfigResourceResponse);
  free(_logConfigResourceResponse);
}

/**
 * Reads a LogConfigResourceResponse element from XML. The element to be read is "log-config", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LogConfigResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_logConfigResourceResponse *xmlTextReaderReadNs0Log_configElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "log-config", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}log-config.\n");
#endif
    _logConfigResourceResponse = xmlTextReaderReadNs0LogConfigResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_logConfigResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}log-config failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}log-config failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _logConfigResourceResponse;
}

/**
 * Writes a LogConfigResourceResponse to XML under element name "log-config".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Log_configElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse) {
  return xmlTextWriterWriteNs0Log_configElementNS(writer, _logConfigResourceResponse, 0);
}

/**
 * Writes a LogConfigResourceResponse to XML under element name "log-config".
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Log_configElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "log-config", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}log-config. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}logConfigResourceResponse for root element {}log-config...\n");
#endif
  status = xmlTextWriterWriteNs0LogConfigResourceResponseType(writer, _logConfigResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}log-config. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}log-config. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LogConfigResourceResponse.
 *
 * @param _logConfigResourceResponse The LogConfigResourceResponse whose children are to be free.
 */
static void freeNs0Log_configElement(struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse) {
  freeNs0LogConfigResourceResponseType(_logConfigResourceResponse);
}

/**
 * Reads a LogConfigResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the LogConfigResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_logConfigResourceResponse *xmlTextReaderReadNs0LogConfigResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_logConfigResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LogConfigResourceResponseType(_logConfigResourceResponse);
        free(_logConfigResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}log-config-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Log_config_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}log-config-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LogConfigResourceResponseType(_logConfigResourceResponse);
          free(_logConfigResourceResponse);
          return NULL;
        }

        _logConfigResourceResponse->data = ((struct nexus_rest_api_ns0_log_config_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}logConfigResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}logConfigResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _logConfigResourceResponse;
}

/**
 * Writes a LogConfigResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _logConfigResourceResponse The LogConfigResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LogConfigResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_logConfigResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}log-config-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Log_config_resourceType(writer, (_logConfigResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}log-config-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LogConfigResourceResponse.
 *
 * @param _logConfigResourceResponse The LogConfigResourceResponse to free.
 */
static void freeNs0LogConfigResourceResponseType(struct nexus_rest_api_ns0_logConfigResourceResponse *_logConfigResourceResponse) {
  int i;
  if (_logConfigResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_logConfigResourceResponse...\n");
#endif
    freeNs0Log_config_resourceType(_logConfigResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_logConfigResourceResponse...\n");
#endif
    free(_logConfigResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_logConfigResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_mirror_resource_M
#define DEF_nexus_rest_api_ns0_mirror_resource_M

/**
 * Reads a MirrorResource from XML. The reader is assumed to be at the start element.
 *
 * @return the MirrorResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_mirror_resource *xmlTextReaderReadNs0Mirror_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_mirror_resource *_mirrorResource = calloc(1, sizeof(struct nexus_rest_api_ns0_mirror_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Mirror_resourceType(_mirrorResource);
        free(_mirrorResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Mirror_resourceType(_mirrorResource);
          free(_mirrorResource);
          return NULL;
        }

        _mirrorResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "url", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Mirror_resourceType(_mirrorResource);
          free(_mirrorResource);
          return NULL;
        }

        _mirrorResource->url = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}mirror-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}mirror-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _mirrorResource;
}

/**
 * Writes a MirrorResource to XML.
 *
 * @param writer The XML writer.
 * @param _mirrorResource The MirrorResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Mirror_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirror_resource *_mirrorResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_mirrorResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_mirrorResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_mirrorResource->url != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "url", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}url...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_mirrorResource->url));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a MirrorResource.
 *
 * @param _mirrorResource The MirrorResource to free.
 */
static void freeNs0Mirror_resourceType(struct nexus_rest_api_ns0_mirror_resource *_mirrorResource) {
  int i;
  if (_mirrorResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_mirror_resource...\n");
#endif
    freeXsStringType(_mirrorResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_mirror_resource...\n");
#endif
    free(_mirrorResource->id);
  }
  if (_mirrorResource->url != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor url of type nexus_rest_api_ns0_mirror_resource...\n");
#endif
    freeXsStringType(_mirrorResource->url);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor url of type nexus_rest_api_ns0_mirror_resource...\n");
#endif
    free(_mirrorResource->url);
  }
}
#endif /* DEF_nexus_rest_api_ns0_mirror_resource_M */
#ifndef DEF_nexus_rest_api_ns0_mirrorResourceListRequest_M
#define DEF_nexus_rest_api_ns0_mirrorResourceListRequest_M

/**
 * Reads a MirrorResourceListRequest element from XML. The element to be read is "mirror-list-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The MirrorResourceListRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_mirrorResourceListRequest *xml_read_nexus_rest_api_ns0_mirrorResourceListRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Mirror_list_requestElement(reader);
}

/**
 * Writes a MirrorResourceListRequest to XML under element name "mirror-list-request".
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_mirrorResourceListRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest) {
  return xmlTextWriterWriteNs0Mirror_list_requestElementNS(writer, _mirrorResourceListRequest, 1);
}

/**
 * Frees a MirrorResourceListRequest.
 *
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to free.
 */
void free_nexus_rest_api_ns0_mirrorResourceListRequest(struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest) {
  freeNs0MirrorResourceListRequestType(_mirrorResourceListRequest);
  free(_mirrorResourceListRequest);
}

/**
 * Reads a MirrorResourceListRequest element from XML. The element to be read is "mirror-list-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The MirrorResourceListRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_mirrorResourceListRequest *xmlTextReaderReadNs0Mirror_list_requestElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "mirror-list-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}mirror-list-request.\n");
#endif
    _mirrorResourceListRequest = xmlTextReaderReadNs0MirrorResourceListRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_mirrorResourceListRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}mirror-list-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}mirror-list-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _mirrorResourceListRequest;
}

/**
 * Writes a MirrorResourceListRequest to XML under element name "mirror-list-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Mirror_list_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest) {
  return xmlTextWriterWriteNs0Mirror_list_requestElementNS(writer, _mirrorResourceListRequest, 0);
}

/**
 * Writes a MirrorResourceListRequest to XML under element name "mirror-list-request".
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Mirror_list_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "mirror-list-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}mirror-list-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}mirrorResourceListRequest for root element {}mirror-list-request...\n");
#endif
  status = xmlTextWriterWriteNs0MirrorResourceListRequestType(writer, _mirrorResourceListRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}mirror-list-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}mirror-list-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a MirrorResourceListRequest.
 *
 * @param _mirrorResourceListRequest The MirrorResourceListRequest whose children are to be free.
 */
static void freeNs0Mirror_list_requestElement(struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest) {
  freeNs0MirrorResourceListRequestType(_mirrorResourceListRequest);
}

/**
 * Reads a MirrorResourceListRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the MirrorResourceListRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_mirrorResourceListRequest *xmlTextReaderReadNs0MirrorResourceListRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest = calloc(1, sizeof(struct nexus_rest_api_ns0_mirrorResourceListRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0MirrorResourceListRequestType(_mirrorResourceListRequest);
        free(_mirrorResourceListRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0MirrorResourceListRequestType(_mirrorResourceListRequest);
              free(_mirrorResourceListRequest);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "mirrorResource", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}mirrorResource of type {}mirror-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Mirror_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}mirrorResource of type {}mirror-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0MirrorResourceListRequestType(_mirrorResourceListRequest);
          free(_mirrorResourceListRequest);
          return NULL;
        }

        _mirrorResourceListRequest->data = realloc(_mirrorResourceListRequest->data, (_mirrorResourceListRequest->_sizeof_data + 1) * sizeof(struct nexus_rest_api_ns0_mirror_resource));
        memcpy(&(_mirrorResourceListRequest->data[_mirrorResourceListRequest->_sizeof_data++]), _child_accessor, sizeof(struct nexus_rest_api_ns0_mirror_resource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0MirrorResourceListRequestType(_mirrorResourceListRequest);
          free(_mirrorResourceListRequest);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}mirrorResourceListRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}mirrorResourceListRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _mirrorResourceListRequest;
}

/**
 * Writes a MirrorResourceListRequest to XML.
 *
 * @param writer The XML writer.
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0MirrorResourceListRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_mirrorResourceListRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _mirrorResourceListRequest->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "mirrorResource", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}mirrorResource. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}mirror-resource for element {}mirrorResource...\n", status);
#endif
    status = xmlTextWriterWriteNs0Mirror_resourceType(writer, &(_mirrorResourceListRequest->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}mirror-resource for element {}mirrorResource. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}mirrorResource. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_mirrorResourceListRequest->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a MirrorResourceListRequest.
 *
 * @param _mirrorResourceListRequest The MirrorResourceListRequest to free.
 */
static void freeNs0MirrorResourceListRequestType(struct nexus_rest_api_ns0_mirrorResourceListRequest *_mirrorResourceListRequest) {
  int i;
  if (_mirrorResourceListRequest->data != NULL) {
    for (i = 0; i < _mirrorResourceListRequest->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_rest_api_ns0_mirrorResourceListRequest...\n", i);
#endif
      freeNs0Mirror_resourceType(&(_mirrorResourceListRequest->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_mirrorResourceListRequest...\n");
#endif
    free(_mirrorResourceListRequest->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_mirrorResourceListRequest_M */
#ifndef DEF_nexus_rest_api_ns0_nexusResponse_M
#define DEF_nexus_rest_api_ns0_nexusResponse_M

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_nexusResponse *_nexusResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_nexusResponse));




  return _nexusResponse;
}

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_nexusResponse *_nexusResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  return totalBytes;
}

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_rest_api_ns0_nexusResponse *_nexusResponse) {
  int i;
}
#endif /* DEF_nexus_rest_api_ns0_nexusResponse_M */
#ifndef DEF_nexus_rest_api_ns0_privilege_M
#define DEF_nexus_rest_api_ns0_privilege_M

/**
 * Reads a PrivilegeResource from XML. The reader is assumed to be at the start element.
 *
 * @return the PrivilegeResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_privilege *xmlTextReaderReadNs0PrivilegeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_privilege *_privilegeResource = calloc(1, sizeof(struct nexus_rest_api_ns0_privilege));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PrivilegeType(_privilegeResource);
        free(_privilegeResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryTargetId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryTargetId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryTargetId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->repositoryTargetId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "type", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}type of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}type of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->type = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "methods", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}methods...\n");
#endif
          //start wrapper element "{}methods"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0PrivilegeType(_privilegeResource);
              free(_privilegeResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "method", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}method of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}method of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->method = realloc(_privilegeResource->method, (_privilegeResource->_sizeof_method + 1) * sizeof(xmlChar));
        memcpy(&(_privilegeResource->method[_privilegeResource->_sizeof_method++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}methods.\n");
#endif
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }
        else {
          //end wrapper element "{}methods"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryGroupId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryGroupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryGroupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeType(_privilegeResource);
          free(_privilegeResource);
          return NULL;
        }

        _privilegeResource->repositoryGroupId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}privilege.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}privilege. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _privilegeResource;
}

/**
 * Writes a PrivilegeResource to XML.
 *
 * @param writer The XML writer.
 * @param _privilegeResource The PrivilegeResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PrivilegeType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilege *_privilegeResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_privilegeResource->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_privilegeResource->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_privilegeResource->repositoryTargetId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryTargetId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryTargetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryTargetId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_privilegeResource->repositoryTargetId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryTargetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryTargetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_privilegeResource->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_privilegeResource->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_privilegeResource->type != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "type", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}type...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_privilegeResource->type));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_privilegeResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_privilegeResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_privilegeResource->method != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "methods", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}methods. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _privilegeResource->_sizeof_method; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "method", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}method. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}method...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_privilegeResource->method[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}method. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}method. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_privilegeResource->method != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}methods. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_privilegeResource->repositoryGroupId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryGroupId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryGroupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryGroupId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_privilegeResource->repositoryGroupId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryGroupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryGroupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PrivilegeResource.
 *
 * @param _privilegeResource The PrivilegeResource to free.
 */
static void freeNs0PrivilegeType(struct nexus_rest_api_ns0_privilege *_privilegeResource) {
  int i;
  if (_privilegeResource->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_rest_api_ns0_privilege...\n");
#endif
    freeXsStringType(_privilegeResource->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->repositoryId);
  }
  if (_privilegeResource->repositoryTargetId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryTargetId of type nexus_rest_api_ns0_privilege...\n");
#endif
    freeXsStringType(_privilegeResource->repositoryTargetId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryTargetId of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->repositoryTargetId);
  }
  if (_privilegeResource->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_rest_api_ns0_privilege...\n");
#endif
    freeXsStringType(_privilegeResource->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->description);
  }
  if (_privilegeResource->type != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor type of type nexus_rest_api_ns0_privilege...\n");
#endif
    freeXsStringType(_privilegeResource->type);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor type of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->type);
  }
  if (_privilegeResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_privilege...\n");
#endif
    freeXsStringType(_privilegeResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->name);
  }
  if (_privilegeResource->method != NULL) {
    for (i = 0; i < _privilegeResource->_sizeof_method; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor method[%i] of type nexus_rest_api_ns0_privilege...\n", i);
#endif
      freeXsStringType(&(_privilegeResource->method[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor method of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->method);
  }
  if (_privilegeResource->repositoryGroupId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryGroupId of type nexus_rest_api_ns0_privilege...\n");
#endif
    freeXsStringType(_privilegeResource->repositoryGroupId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryGroupId of type nexus_rest_api_ns0_privilege...\n");
#endif
    free(_privilegeResource->repositoryGroupId);
  }
}
#endif /* DEF_nexus_rest_api_ns0_privilege_M */
#ifndef DEF_nexus_rest_api_ns0_privilegeResourceRequest_M
#define DEF_nexus_rest_api_ns0_privilegeResourceRequest_M

/**
 * Reads a PrivilegeResourceRequest element from XML. The element to be read is "privilege-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The PrivilegeResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_privilegeResourceRequest *xml_read_nexus_rest_api_ns0_privilegeResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Privilege_requestElement(reader);
}

/**
 * Writes a PrivilegeResourceRequest to XML under element name "privilege-request".
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_privilegeResourceRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest) {
  return xmlTextWriterWriteNs0Privilege_requestElementNS(writer, _privilegeResourceRequest, 1);
}

/**
 * Frees a PrivilegeResourceRequest.
 *
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to free.
 */
void free_nexus_rest_api_ns0_privilegeResourceRequest(struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest) {
  freeNs0PrivilegeResourceRequestType(_privilegeResourceRequest);
  free(_privilegeResourceRequest);
}

/**
 * Reads a PrivilegeResourceRequest element from XML. The element to be read is "privilege-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The PrivilegeResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_privilegeResourceRequest *xmlTextReaderReadNs0Privilege_requestElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "privilege-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}privilege-request.\n");
#endif
    _privilegeResourceRequest = xmlTextReaderReadNs0PrivilegeResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_privilegeResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}privilege-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}privilege-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _privilegeResourceRequest;
}

/**
 * Writes a PrivilegeResourceRequest to XML under element name "privilege-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Privilege_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest) {
  return xmlTextWriterWriteNs0Privilege_requestElementNS(writer, _privilegeResourceRequest, 0);
}

/**
 * Writes a PrivilegeResourceRequest to XML under element name "privilege-request".
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Privilege_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "privilege-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}privilege-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}privilegeResourceRequest for root element {}privilege-request...\n");
#endif
  status = xmlTextWriterWriteNs0PrivilegeResourceRequestType(writer, _privilegeResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}privilege-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}privilege-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a PrivilegeResourceRequest.
 *
 * @param _privilegeResourceRequest The PrivilegeResourceRequest whose children are to be free.
 */
static void freeNs0Privilege_requestElement(struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest) {
  freeNs0PrivilegeResourceRequestType(_privilegeResourceRequest);
}

/**
 * Reads a PrivilegeResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the PrivilegeResourceRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_privilegeResourceRequest *xmlTextReaderReadNs0PrivilegeResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest = calloc(1, sizeof(struct nexus_rest_api_ns0_privilegeResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PrivilegeResourceRequestType(_privilegeResourceRequest);
        free(_privilegeResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}privilege.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0PrivilegeType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}privilege.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PrivilegeResourceRequestType(_privilegeResourceRequest);
          free(_privilegeResourceRequest);
          return NULL;
        }

        _privilegeResourceRequest->data = ((struct nexus_rest_api_ns0_privilege*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}privilegeResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}privilegeResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _privilegeResourceRequest;
}

/**
 * Writes a PrivilegeResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PrivilegeResourceRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_privilegeResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}privilege for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0PrivilegeType(writer, (_privilegeResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}privilege for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PrivilegeResourceRequest.
 *
 * @param _privilegeResourceRequest The PrivilegeResourceRequest to free.
 */
static void freeNs0PrivilegeResourceRequestType(struct nexus_rest_api_ns0_privilegeResourceRequest *_privilegeResourceRequest) {
  int i;
  if (_privilegeResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_privilegeResourceRequest...\n");
#endif
    freeNs0PrivilegeType(_privilegeResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_privilegeResourceRequest...\n");
#endif
    free(_privilegeResourceRequest->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_privilegeResourceRequest_M */
#ifndef DEF_nexus_rest_api_ns0_remote_connection_settings_M
#define DEF_nexus_rest_api_ns0_remote_connection_settings_M

/**
 * Reads a RemoteConnectionSettings from XML. The reader is assumed to be at the start element.
 *
 * @return the RemoteConnectionSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_remote_connection_settings *xmlTextReaderReadNs0Remote_connection_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_remote_connection_settings *_remoteConnectionSettings = calloc(1, sizeof(struct nexus_rest_api_ns0_remote_connection_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Remote_connection_settingsType(_remoteConnectionSettings);
        free(_remoteConnectionSettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userAgentString", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userAgentString of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userAgentString of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_connection_settingsType(_remoteConnectionSettings);
          free(_remoteConnectionSettings);
          return NULL;
        }

        _remoteConnectionSettings->userAgentString = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "retrievalRetryCount", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}retrievalRetryCount of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}retrievalRetryCount of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_connection_settingsType(_remoteConnectionSettings);
          free(_remoteConnectionSettings);
          return NULL;
        }

        _remoteConnectionSettings->retrievalRetryCount = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "queryString", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}queryString of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}queryString of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_connection_settingsType(_remoteConnectionSettings);
          free(_remoteConnectionSettings);
          return NULL;
        }

        _remoteConnectionSettings->queryString = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "connectionTimeout", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}connectionTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}connectionTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_connection_settingsType(_remoteConnectionSettings);
          free(_remoteConnectionSettings);
          return NULL;
        }

        _remoteConnectionSettings->connectionTimeout = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}remote-connection-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}remote-connection-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _remoteConnectionSettings;
}

/**
 * Writes a RemoteConnectionSettings to XML.
 *
 * @param writer The XML writer.
 * @param _remoteConnectionSettings The RemoteConnectionSettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Remote_connection_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_remote_connection_settings *_remoteConnectionSettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_remoteConnectionSettings->userAgentString != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAgentString", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userAgentString. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userAgentString...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_remoteConnectionSettings->userAgentString));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userAgentString. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userAgentString. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "retrievalRetryCount", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}retrievalRetryCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}retrievalRetryCount...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_remoteConnectionSettings->retrievalRetryCount));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}retrievalRetryCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}retrievalRetryCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_remoteConnectionSettings->queryString != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "queryString", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}queryString. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}queryString...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_remoteConnectionSettings->queryString));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}queryString. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}queryString. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "connectionTimeout", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}connectionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}connectionTimeout...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_remoteConnectionSettings->connectionTimeout));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}connectionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}connectionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RemoteConnectionSettings.
 *
 * @param _remoteConnectionSettings The RemoteConnectionSettings to free.
 */
static void freeNs0Remote_connection_settingsType(struct nexus_rest_api_ns0_remote_connection_settings *_remoteConnectionSettings) {
  int i;
  if (_remoteConnectionSettings->userAgentString != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userAgentString of type nexus_rest_api_ns0_remote_connection_settings...\n");
#endif
    freeXsStringType(_remoteConnectionSettings->userAgentString);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userAgentString of type nexus_rest_api_ns0_remote_connection_settings...\n");
#endif
    free(_remoteConnectionSettings->userAgentString);
  }
  if (_remoteConnectionSettings->queryString != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor queryString of type nexus_rest_api_ns0_remote_connection_settings...\n");
#endif
    freeXsStringType(_remoteConnectionSettings->queryString);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor queryString of type nexus_rest_api_ns0_remote_connection_settings...\n");
#endif
    free(_remoteConnectionSettings->queryString);
  }
}
#endif /* DEF_nexus_rest_api_ns0_remote_connection_settings_M */
#ifndef DEF_nexus_rest_api_ns0_remote_http_proxy_settings_M
#define DEF_nexus_rest_api_ns0_remote_http_proxy_settings_M

/**
 * Reads a RemoteHttpProxySettings from XML. The reader is assumed to be at the start element.
 *
 * @return the RemoteHttpProxySettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_remote_http_proxy_settings *xmlTextReaderReadNs0Remote_http_proxy_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_remote_http_proxy_settings *_remoteHttpProxySettings = calloc(1, sizeof(struct nexus_rest_api_ns0_remote_http_proxy_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Remote_http_proxy_settingsType(_remoteHttpProxySettings);
        free(_remoteHttpProxySettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "nonProxyHosts", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}nonProxyHosts of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}nonProxyHosts of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_http_proxy_settingsType(_remoteHttpProxySettings);
          free(_remoteHttpProxySettings);
          return NULL;
        }

        _remoteHttpProxySettings->nonProxyHosts = realloc(_remoteHttpProxySettings->nonProxyHosts, (_remoteHttpProxySettings->_sizeof_nonProxyHosts + 1) * sizeof(xmlChar));
        memcpy(&(_remoteHttpProxySettings->nonProxyHosts[_remoteHttpProxySettings->_sizeof_nonProxyHosts++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "proxyPort", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}proxyPort of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}proxyPort of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_http_proxy_settingsType(_remoteHttpProxySettings);
          free(_remoteHttpProxySettings);
          return NULL;
        }

        _remoteHttpProxySettings->proxyPort = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "authentication", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}authentication of type {}authentication-settings.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Authentication_settingsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}authentication of type {}authentication-settings.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_http_proxy_settingsType(_remoteHttpProxySettings);
          free(_remoteHttpProxySettings);
          return NULL;
        }

        _remoteHttpProxySettings->authentication = ((struct nexus_rest_api_ns0_authentication_settings*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "proxyHostname", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}proxyHostname of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}proxyHostname of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Remote_http_proxy_settingsType(_remoteHttpProxySettings);
          free(_remoteHttpProxySettings);
          return NULL;
        }

        _remoteHttpProxySettings->proxyHostname = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}remote-http-proxy-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}remote-http-proxy-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _remoteHttpProxySettings;
}

/**
 * Writes a RemoteHttpProxySettings to XML.
 *
 * @param writer The XML writer.
 * @param _remoteHttpProxySettings The RemoteHttpProxySettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Remote_http_proxy_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_remote_http_proxy_settings *_remoteHttpProxySettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  for (i = 0; i < _remoteHttpProxySettings->_sizeof_nonProxyHosts; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "nonProxyHosts", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}nonProxyHosts. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}nonProxyHosts...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_remoteHttpProxySettings->nonProxyHosts[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}nonProxyHosts. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}nonProxyHosts. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "proxyPort", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}proxyPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}proxyPort...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_remoteHttpProxySettings->proxyPort));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}proxyPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}proxyPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_remoteHttpProxySettings->authentication != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "authentication", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}authentication. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}authentication-settings for element {}authentication...\n", status);
#endif
    status = xmlTextWriterWriteNs0Authentication_settingsType(writer, (_remoteHttpProxySettings->authentication));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}authentication-settings for element {}authentication. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}authentication. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_remoteHttpProxySettings->proxyHostname != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "proxyHostname", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}proxyHostname. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}proxyHostname...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_remoteHttpProxySettings->proxyHostname));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}proxyHostname. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}proxyHostname. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RemoteHttpProxySettings.
 *
 * @param _remoteHttpProxySettings The RemoteHttpProxySettings to free.
 */
static void freeNs0Remote_http_proxy_settingsType(struct nexus_rest_api_ns0_remote_http_proxy_settings *_remoteHttpProxySettings) {
  int i;
  if (_remoteHttpProxySettings->nonProxyHosts != NULL) {
    for (i = 0; i < _remoteHttpProxySettings->_sizeof_nonProxyHosts; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor nonProxyHosts[%i] of type nexus_rest_api_ns0_remote_http_proxy_settings...\n", i);
#endif
      freeXsStringType(&(_remoteHttpProxySettings->nonProxyHosts[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor nonProxyHosts of type nexus_rest_api_ns0_remote_http_proxy_settings...\n");
#endif
    free(_remoteHttpProxySettings->nonProxyHosts);
  }
  if (_remoteHttpProxySettings->authentication != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor authentication of type nexus_rest_api_ns0_remote_http_proxy_settings...\n");
#endif
    freeNs0Authentication_settingsType(_remoteHttpProxySettings->authentication);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor authentication of type nexus_rest_api_ns0_remote_http_proxy_settings...\n");
#endif
    free(_remoteHttpProxySettings->authentication);
  }
  if (_remoteHttpProxySettings->proxyHostname != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor proxyHostname of type nexus_rest_api_ns0_remote_http_proxy_settings...\n");
#endif
    freeXsStringType(_remoteHttpProxySettings->proxyHostname);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor proxyHostname of type nexus_rest_api_ns0_remote_http_proxy_settings...\n");
#endif
    free(_remoteHttpProxySettings->proxyHostname);
  }
}
#endif /* DEF_nexus_rest_api_ns0_remote_http_proxy_settings_M */
#ifndef DEF_nexus_rest_api_ns0_base_repository_M
#define DEF_nexus_rest_api_ns0_base_repository_M

/**
 * Reads a RepositoryBaseResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryBaseResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_base_repository *xmlTextReaderReadNs0Base_repositoryType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_base_repository *_repositoryBaseResource = calloc(1, sizeof(struct nexus_rest_api_ns0_base_repository));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Base_repositoryType(_repositoryBaseResource);
        free(_repositoryBaseResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "provider", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}provider of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}provider of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->provider = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "exposed", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}exposed of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}exposed of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->exposed = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repoType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->repoType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "format", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->format = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "providerRole", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}providerRole of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}providerRole of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->providerRole = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contentResourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contentResourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contentResourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Base_repositoryType(_repositoryBaseResource);
          free(_repositoryBaseResource);
          return NULL;
        }

        _repositoryBaseResource->contentResourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}base-repository.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}base-repository. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryBaseResource;
}

/**
 * Writes a RepositoryBaseResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryBaseResource The RepositoryBaseResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Base_repositoryType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_base_repository *_repositoryBaseResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryBaseResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryBaseResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryBaseResource->provider != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "provider", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}provider. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}provider...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->provider));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}provider. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}provider. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "exposed", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}exposed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}exposed...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_repositoryBaseResource->exposed));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}exposed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}exposed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryBaseResource->repoType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repoType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repoType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->repoType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryBaseResource->format != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "format", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}format...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->format));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryBaseResource->providerRole != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "providerRole", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}providerRole. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}providerRole...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->providerRole));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}providerRole. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}providerRole. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryBaseResource->contentResourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contentResourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contentResourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contentResourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryBaseResource->contentResourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contentResourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contentResourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryBaseResource.
 *
 * @param _repositoryBaseResource The RepositoryBaseResource to free.
 */
static void freeNs0Base_repositoryType(struct nexus_rest_api_ns0_base_repository *_repositoryBaseResource) {
  int i;
  if (_repositoryBaseResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->id);
  }
  if (_repositoryBaseResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->name);
  }
  if (_repositoryBaseResource->provider != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor provider of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->provider);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor provider of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->provider);
  }
  if (_repositoryBaseResource->repoType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repoType of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->repoType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repoType of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->repoType);
  }
  if (_repositoryBaseResource->format != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor format of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->format);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor format of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->format);
  }
  if (_repositoryBaseResource->providerRole != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor providerRole of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->providerRole);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor providerRole of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->providerRole);
  }
  if (_repositoryBaseResource->contentResourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contentResourceURI of type nexus_rest_api_ns0_base_repository...\n");
#endif
    freeXsStringType(_repositoryBaseResource->contentResourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contentResourceURI of type nexus_rest_api_ns0_base_repository...\n");
#endif
    free(_repositoryBaseResource->contentResourceURI);
  }
}
#endif /* DEF_nexus_rest_api_ns0_base_repository_M */
#ifndef DEF_nexus_rest_api_ns0_repository_dependent_status_M
#define DEF_nexus_rest_api_ns0_repository_dependent_status_M

/**
 * Reads a RepositoryDependentStatusResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryDependentStatusResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_dependent_status *xmlTextReaderReadNs0Repository_dependent_statusType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_dependent_status *_repositoryDependentStatusResource = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_dependent_status));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_dependent_statusType(_repositoryDependentStatusResource);
        free(_repositoryDependentStatusResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "localStatus", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}localStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}localStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_dependent_statusType(_repositoryDependentStatusResource);
          free(_repositoryDependentStatusResource);
          return NULL;
        }

        _repositoryDependentStatusResource->localStatus = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "format", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_dependent_statusType(_repositoryDependentStatusResource);
          free(_repositoryDependentStatusResource);
          return NULL;
        }

        _repositoryDependentStatusResource->format = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repoType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_dependent_statusType(_repositoryDependentStatusResource);
          free(_repositoryDependentStatusResource);
          return NULL;
        }

        _repositoryDependentStatusResource->repoType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_dependent_statusType(_repositoryDependentStatusResource);
          free(_repositoryDependentStatusResource);
          return NULL;
        }

        _repositoryDependentStatusResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-dependent-status.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-dependent-status. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryDependentStatusResource;
}

/**
 * Writes a RepositoryDependentStatusResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryDependentStatusResource The RepositoryDependentStatusResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_dependent_statusType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_dependent_status *_repositoryDependentStatusResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryDependentStatusResource->localStatus != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "localStatus", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}localStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}localStatus...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryDependentStatusResource->localStatus));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}localStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}localStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryDependentStatusResource->format != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "format", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}format...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryDependentStatusResource->format));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryDependentStatusResource->repoType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repoType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repoType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryDependentStatusResource->repoType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryDependentStatusResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryDependentStatusResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryDependentStatusResource.
 *
 * @param _repositoryDependentStatusResource The RepositoryDependentStatusResource to free.
 */
static void freeNs0Repository_dependent_statusType(struct nexus_rest_api_ns0_repository_dependent_status *_repositoryDependentStatusResource) {
  int i;
  if (_repositoryDependentStatusResource->localStatus != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor localStatus of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    freeXsStringType(_repositoryDependentStatusResource->localStatus);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor localStatus of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    free(_repositoryDependentStatusResource->localStatus);
  }
  if (_repositoryDependentStatusResource->format != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor format of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    freeXsStringType(_repositoryDependentStatusResource->format);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor format of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    free(_repositoryDependentStatusResource->format);
  }
  if (_repositoryDependentStatusResource->repoType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repoType of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    freeXsStringType(_repositoryDependentStatusResource->repoType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repoType of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    free(_repositoryDependentStatusResource->repoType);
  }
  if (_repositoryDependentStatusResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    freeXsStringType(_repositoryDependentStatusResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_dependent_status...\n");
#endif
    free(_repositoryDependentStatusResource->id);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_dependent_status_M */
#ifndef DEF_nexus_rest_api_ns0_repository_group_member_repository_M
#define DEF_nexus_rest_api_ns0_repository_group_member_repository_M

/**
 * Reads a RepositoryGroupMemberRepository from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryGroupMemberRepository, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_group_member_repository *xmlTextReaderReadNs0Repository_group_member_repositoryType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_group_member_repository *_repositoryGroupMemberRepository = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_group_member_repository));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_group_member_repositoryType(_repositoryGroupMemberRepository);
        free(_repositoryGroupMemberRepository);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_member_repositoryType(_repositoryGroupMemberRepository);
          free(_repositoryGroupMemberRepository);
          return NULL;
        }

        _repositoryGroupMemberRepository->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_member_repositoryType(_repositoryGroupMemberRepository);
          free(_repositoryGroupMemberRepository);
          return NULL;
        }

        _repositoryGroupMemberRepository->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_member_repositoryType(_repositoryGroupMemberRepository);
          free(_repositoryGroupMemberRepository);
          return NULL;
        }

        _repositoryGroupMemberRepository->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-group-member-repository.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-group-member-repository. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryGroupMemberRepository;
}

/**
 * Writes a RepositoryGroupMemberRepository to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupMemberRepository The RepositoryGroupMemberRepository to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_group_member_repositoryType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_group_member_repository *_repositoryGroupMemberRepository) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryGroupMemberRepository->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupMemberRepository->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupMemberRepository->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupMemberRepository->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupMemberRepository->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupMemberRepository->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryGroupMemberRepository.
 *
 * @param _repositoryGroupMemberRepository The RepositoryGroupMemberRepository to free.
 */
static void freeNs0Repository_group_member_repositoryType(struct nexus_rest_api_ns0_repository_group_member_repository *_repositoryGroupMemberRepository) {
  int i;
  if (_repositoryGroupMemberRepository->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_rest_api_ns0_repository_group_member_repository...\n");
#endif
    freeXsStringType(_repositoryGroupMemberRepository->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_rest_api_ns0_repository_group_member_repository...\n");
#endif
    free(_repositoryGroupMemberRepository->resourceURI);
  }
  if (_repositoryGroupMemberRepository->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_group_member_repository...\n");
#endif
    freeXsStringType(_repositoryGroupMemberRepository->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_group_member_repository...\n");
#endif
    free(_repositoryGroupMemberRepository->id);
  }
  if (_repositoryGroupMemberRepository->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_repository_group_member_repository...\n");
#endif
    freeXsStringType(_repositoryGroupMemberRepository->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_repository_group_member_repository...\n");
#endif
    free(_repositoryGroupMemberRepository->name);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_group_member_repository_M */
#ifndef DEF_nexus_rest_api_ns0_repository_group_resource_M
#define DEF_nexus_rest_api_ns0_repository_group_resource_M

/**
 * Reads a RepositoryGroupResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryGroupResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_group_resource *xmlTextReaderReadNs0Repository_group_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_group_resource *_repositoryGroupResource = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_group_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_group_resourceType(_repositoryGroupResource);
        free(_repositoryGroupResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "provider", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}provider of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}provider of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->provider = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "exposed", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}exposed of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}exposed of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->exposed = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repoType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->repoType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "format", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->format = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "providerRole", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}providerRole of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}providerRole of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->providerRole = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contentResourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contentResourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contentResourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->contentResourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositories", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}repositories...\n");
#endif
          //start wrapper element "{}repositories"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Repository_group_resourceType(_repositoryGroupResource);
              free(_repositoryGroupResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repo-group-member", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repo-group-member of type {}repository-group-member-repository.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_group_member_repositoryType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repo-group-member of type {}repository-group-member-repository.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }

        _repositoryGroupResource->repositories = realloc(_repositoryGroupResource->repositories, (_repositoryGroupResource->_sizeof_repositories + 1) * sizeof(struct nexus_rest_api_ns0_repository_group_member_repository));
        memcpy(&(_repositoryGroupResource->repositories[_repositoryGroupResource->_sizeof_repositories++]), _child_accessor, sizeof(struct nexus_rest_api_ns0_repository_group_member_repository));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}repositories.\n");
#endif
          freeNs0Repository_group_resourceType(_repositoryGroupResource);
          free(_repositoryGroupResource);
          return NULL;
        }
        else {
          //end wrapper element "{}repositories"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-group-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-group-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryGroupResource;
}

/**
 * Writes a RepositoryGroupResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResource The RepositoryGroupResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_group_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_group_resource *_repositoryGroupResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryGroupResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupResource->provider != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "provider", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}provider. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}provider...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->provider));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}provider. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}provider. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "exposed", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}exposed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}exposed...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_repositoryGroupResource->exposed));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}exposed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}exposed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupResource->repoType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repoType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repoType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->repoType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupResource->format != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "format", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}format...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->format));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupResource->providerRole != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "providerRole", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}providerRole. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}providerRole...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->providerRole));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}providerRole. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}providerRole. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryGroupResource->contentResourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contentResourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contentResourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contentResourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryGroupResource->contentResourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contentResourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contentResourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryGroupResource->repositories != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositories", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _repositoryGroupResource->_sizeof_repositories; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repo-group-member", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repo-group-member. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-group-member-repository for element {}repo-group-member...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_group_member_repositoryType(writer, &(_repositoryGroupResource->repositories[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-group-member-repository for element {}repo-group-member. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repo-group-member. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryGroupResource->repositories != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryGroupResource.
 *
 * @param _repositoryGroupResource The RepositoryGroupResource to free.
 */
static void freeNs0Repository_group_resourceType(struct nexus_rest_api_ns0_repository_group_resource *_repositoryGroupResource) {
  int i;
  if (_repositoryGroupResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->id);
  }
  if (_repositoryGroupResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->name);
  }
  if (_repositoryGroupResource->provider != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor provider of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->provider);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor provider of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->provider);
  }
  if (_repositoryGroupResource->repoType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repoType of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->repoType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repoType of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->repoType);
  }
  if (_repositoryGroupResource->format != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor format of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->format);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor format of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->format);
  }
  if (_repositoryGroupResource->providerRole != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor providerRole of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->providerRole);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor providerRole of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->providerRole);
  }
  if (_repositoryGroupResource->contentResourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contentResourceURI of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    freeXsStringType(_repositoryGroupResource->contentResourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contentResourceURI of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->contentResourceURI);
  }
  if (_repositoryGroupResource->repositories != NULL) {
    for (i = 0; i < _repositoryGroupResource->_sizeof_repositories; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor repositories[%i] of type nexus_rest_api_ns0_repository_group_resource...\n", i);
#endif
      freeNs0Repository_group_member_repositoryType(&(_repositoryGroupResource->repositories[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositories of type nexus_rest_api_ns0_repository_group_resource...\n");
#endif
    free(_repositoryGroupResource->repositories);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_group_resource_M */
#ifndef DEF_nexus_rest_api_ns0_repositoryGroupResourceResponse_M
#define DEF_nexus_rest_api_ns0_repositoryGroupResourceResponse_M

/**
 * Reads a RepositoryGroupResourceResponse element from XML. The element to be read is "repo-group", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryGroupResourceResponse *xml_read_nexus_rest_api_ns0_repositoryGroupResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Repo_groupElement(reader);
}

/**
 * Writes a RepositoryGroupResourceResponse to XML under element name "repo-group".
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_repositoryGroupResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse) {
  return xmlTextWriterWriteNs0Repo_groupElementNS(writer, _repositoryGroupResourceResponse, 1);
}

/**
 * Frees a RepositoryGroupResourceResponse.
 *
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryGroupResourceResponse(struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse) {
  freeNs0RepositoryGroupResourceResponseType(_repositoryGroupResourceResponse);
  free(_repositoryGroupResourceResponse);
}

/**
 * Reads a RepositoryGroupResourceResponse element from XML. The element to be read is "repo-group", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RepositoryGroupResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryGroupResourceResponse *xmlTextReaderReadNs0Repo_groupElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "repo-group", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}repo-group.\n");
#endif
    _repositoryGroupResourceResponse = xmlTextReaderReadNs0RepositoryGroupResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_repositoryGroupResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}repo-group failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}repo-group failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _repositoryGroupResourceResponse;
}

/**
 * Writes a RepositoryGroupResourceResponse to XML under element name "repo-group".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repo_groupElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse) {
  return xmlTextWriterWriteNs0Repo_groupElementNS(writer, _repositoryGroupResourceResponse, 0);
}

/**
 * Writes a RepositoryGroupResourceResponse to XML under element name "repo-group".
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repo_groupElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repo-group", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}repo-group. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}repositoryGroupResourceResponse for root element {}repo-group...\n");
#endif
  status = xmlTextWriterWriteNs0RepositoryGroupResourceResponseType(writer, _repositoryGroupResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}repo-group. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}repo-group. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RepositoryGroupResourceResponse.
 *
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse whose children are to be free.
 */
static void freeNs0Repo_groupElement(struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse) {
  freeNs0RepositoryGroupResourceResponseType(_repositoryGroupResourceResponse);
}

/**
 * Reads a RepositoryGroupResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryGroupResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryGroupResourceResponse *xmlTextReaderReadNs0RepositoryGroupResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_repositoryGroupResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RepositoryGroupResourceResponseType(_repositoryGroupResourceResponse);
        free(_repositoryGroupResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}repository-group-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_group_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}repository-group-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryGroupResourceResponseType(_repositoryGroupResourceResponse);
          free(_repositoryGroupResourceResponse);
          return NULL;
        }

        _repositoryGroupResourceResponse->data = ((struct nexus_rest_api_ns0_repository_group_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repositoryGroupResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repositoryGroupResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryGroupResourceResponse;
}

/**
 * Writes a RepositoryGroupResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RepositoryGroupResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryGroupResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-group-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_group_resourceType(writer, (_repositoryGroupResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-group-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryGroupResourceResponse.
 *
 * @param _repositoryGroupResourceResponse The RepositoryGroupResourceResponse to free.
 */
static void freeNs0RepositoryGroupResourceResponseType(struct nexus_rest_api_ns0_repositoryGroupResourceResponse *_repositoryGroupResourceResponse) {
  int i;
  if (_repositoryGroupResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_repositoryGroupResourceResponse...\n");
#endif
    freeNs0Repository_group_resourceType(_repositoryGroupResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_repositoryGroupResourceResponse...\n");
#endif
    free(_repositoryGroupResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repositoryGroupResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_repositoryResourceResponse_M
#define DEF_nexus_rest_api_ns0_repositoryResourceResponse_M

/**
 * Reads a RepositoryResourceResponse element from XML. The element to be read is "repository", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryResourceResponse *xml_read_nexus_rest_api_ns0_repositoryResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0RepositoryElement(reader);
}

/**
 * Writes a RepositoryResourceResponse to XML under element name "repository".
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_repositoryResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse) {
  return xmlTextWriterWriteNs0RepositoryElementNS(writer, _repositoryResourceResponse, 1);
}

/**
 * Frees a RepositoryResourceResponse.
 *
 * @param _repositoryResourceResponse The RepositoryResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryResourceResponse(struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse) {
  freeNs0RepositoryResourceResponseType(_repositoryResourceResponse);
  free(_repositoryResourceResponse);
}

/**
 * Reads a RepositoryResourceResponse element from XML. The element to be read is "repository", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RepositoryResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryResourceResponse *xmlTextReaderReadNs0RepositoryElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "repository", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}repository.\n");
#endif
    _repositoryResourceResponse = xmlTextReaderReadNs0RepositoryResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_repositoryResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}repository failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}repository failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _repositoryResourceResponse;
}

/**
 * Writes a RepositoryResourceResponse to XML under element name "repository".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0RepositoryElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse) {
  return xmlTextWriterWriteNs0RepositoryElementNS(writer, _repositoryResourceResponse, 0);
}

/**
 * Writes a RepositoryResourceResponse to XML under element name "repository".
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0RepositoryElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repository", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}repository. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}repositoryResourceResponse for root element {}repository...\n");
#endif
  status = xmlTextWriterWriteNs0RepositoryResourceResponseType(writer, _repositoryResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}repository. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}repository. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RepositoryResourceResponse.
 *
 * @param _repositoryResourceResponse The RepositoryResourceResponse whose children are to be free.
 */
static void freeNs0RepositoryElement(struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse) {
  freeNs0RepositoryResourceResponseType(_repositoryResourceResponse);
}

/**
 * Reads a RepositoryResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryResourceResponse *xmlTextReaderReadNs0RepositoryResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_repositoryResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RepositoryResourceResponseType(_repositoryResourceResponse);
        free(_repositoryResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}base-repository.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Base_repositoryType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}base-repository.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryResourceResponseType(_repositoryResourceResponse);
          free(_repositoryResourceResponse);
          return NULL;
        }

        _repositoryResourceResponse->data = ((struct nexus_rest_api_ns0_base_repository*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repositoryResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repositoryResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryResourceResponse;
}

/**
 * Writes a RepositoryResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryResourceResponse The RepositoryResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RepositoryResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}base-repository for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Base_repositoryType(writer, (_repositoryResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}base-repository for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryResourceResponse.
 *
 * @param _repositoryResourceResponse The RepositoryResourceResponse to free.
 */
static void freeNs0RepositoryResourceResponseType(struct nexus_rest_api_ns0_repositoryResourceResponse *_repositoryResourceResponse) {
  int i;
  if (_repositoryResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_repositoryResourceResponse...\n");
#endif
    freeNs0Base_repositoryType(_repositoryResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_repositoryResourceResponse...\n");
#endif
    free(_repositoryResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repositoryResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_repository_route_member_repo_M
#define DEF_nexus_rest_api_ns0_repository_route_member_repo_M

/**
 * Reads a RepositoryRouteMemberRepository from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryRouteMemberRepository, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_route_member_repo *xmlTextReaderReadNs0Repository_route_member_repoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_route_member_repo *_repositoryRouteMemberRepository = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_route_member_repo));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_route_member_repoType(_repositoryRouteMemberRepository);
        free(_repositoryRouteMemberRepository);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_member_repoType(_repositoryRouteMemberRepository);
          free(_repositoryRouteMemberRepository);
          return NULL;
        }

        _repositoryRouteMemberRepository->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_member_repoType(_repositoryRouteMemberRepository);
          free(_repositoryRouteMemberRepository);
          return NULL;
        }

        _repositoryRouteMemberRepository->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_member_repoType(_repositoryRouteMemberRepository);
          free(_repositoryRouteMemberRepository);
          return NULL;
        }

        _repositoryRouteMemberRepository->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-route-member-repo.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-route-member-repo. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryRouteMemberRepository;
}

/**
 * Writes a RepositoryRouteMemberRepository to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteMemberRepository The RepositoryRouteMemberRepository to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_route_member_repoType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_route_member_repo *_repositoryRouteMemberRepository) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryRouteMemberRepository->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteMemberRepository->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryRouteMemberRepository->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteMemberRepository->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryRouteMemberRepository->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteMemberRepository->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryRouteMemberRepository.
 *
 * @param _repositoryRouteMemberRepository The RepositoryRouteMemberRepository to free.
 */
static void freeNs0Repository_route_member_repoType(struct nexus_rest_api_ns0_repository_route_member_repo *_repositoryRouteMemberRepository) {
  int i;
  if (_repositoryRouteMemberRepository->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_repository_route_member_repo...\n");
#endif
    freeXsStringType(_repositoryRouteMemberRepository->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_repository_route_member_repo...\n");
#endif
    free(_repositoryRouteMemberRepository->name);
  }
  if (_repositoryRouteMemberRepository->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_rest_api_ns0_repository_route_member_repo...\n");
#endif
    freeXsStringType(_repositoryRouteMemberRepository->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_rest_api_ns0_repository_route_member_repo...\n");
#endif
    free(_repositoryRouteMemberRepository->resourceURI);
  }
  if (_repositoryRouteMemberRepository->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_route_member_repo...\n");
#endif
    freeXsStringType(_repositoryRouteMemberRepository->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_route_member_repo...\n");
#endif
    free(_repositoryRouteMemberRepository->id);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_route_member_repo_M */
#ifndef DEF_nexus_rest_api_ns0_repository_route_resource_M
#define DEF_nexus_rest_api_ns0_repository_route_resource_M

/**
 * Reads a RepositoryRouteResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryRouteResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_route_resource *xmlTextReaderReadNs0Repository_route_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_route_resource *_repositoryRouteResource = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_route_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_route_resourceType(_repositoryRouteResource);
        free(_repositoryRouteResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_resourceType(_repositoryRouteResource);
          free(_repositoryRouteResource);
          return NULL;
        }

        _repositoryRouteResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "pattern", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}pattern of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}pattern of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_resourceType(_repositoryRouteResource);
          free(_repositoryRouteResource);
          return NULL;
        }

        _repositoryRouteResource->pattern = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositories", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}repositories...\n");
#endif
          //start wrapper element "{}repositories"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Repository_route_resourceType(_repositoryRouteResource);
              free(_repositoryRouteResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repository", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repository of type {}repository-route-member-repo.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_route_member_repoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repository of type {}repository-route-member-repo.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_resourceType(_repositoryRouteResource);
          free(_repositoryRouteResource);
          return NULL;
        }

        _repositoryRouteResource->repositories = realloc(_repositoryRouteResource->repositories, (_repositoryRouteResource->_sizeof_repositories + 1) * sizeof(struct nexus_rest_api_ns0_repository_route_member_repo));
        memcpy(&(_repositoryRouteResource->repositories[_repositoryRouteResource->_sizeof_repositories++]), _child_accessor, sizeof(struct nexus_rest_api_ns0_repository_route_member_repo));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}repositories.\n");
#endif
          freeNs0Repository_route_resourceType(_repositoryRouteResource);
          free(_repositoryRouteResource);
          return NULL;
        }
        else {
          //end wrapper element "{}repositories"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_resourceType(_repositoryRouteResource);
          free(_repositoryRouteResource);
          return NULL;
        }

        _repositoryRouteResource->groupId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ruleType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ruleType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ruleType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_route_resourceType(_repositoryRouteResource);
          free(_repositoryRouteResource);
          return NULL;
        }

        _repositoryRouteResource->ruleType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-route-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-route-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryRouteResource;
}

/**
 * Writes a RepositoryRouteResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResource The RepositoryRouteResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_route_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_route_resource *_repositoryRouteResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryRouteResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryRouteResource->pattern != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pattern", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}pattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}pattern...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteResource->pattern));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}pattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}pattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryRouteResource->repositories != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositories", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _repositoryRouteResource->_sizeof_repositories; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repository", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-route-member-repo for element {}repository...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_route_member_repoType(writer, &(_repositoryRouteResource->repositories[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-route-member-repo for element {}repository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryRouteResource->repositories != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryRouteResource->groupId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteResource->groupId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryRouteResource->ruleType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ruleType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ruleType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ruleType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryRouteResource->ruleType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ruleType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ruleType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryRouteResource.
 *
 * @param _repositoryRouteResource The RepositoryRouteResource to free.
 */
static void freeNs0Repository_route_resourceType(struct nexus_rest_api_ns0_repository_route_resource *_repositoryRouteResource) {
  int i;
  if (_repositoryRouteResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    freeXsStringType(_repositoryRouteResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    free(_repositoryRouteResource->id);
  }
  if (_repositoryRouteResource->pattern != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor pattern of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    freeXsStringType(_repositoryRouteResource->pattern);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor pattern of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    free(_repositoryRouteResource->pattern);
  }
  if (_repositoryRouteResource->repositories != NULL) {
    for (i = 0; i < _repositoryRouteResource->_sizeof_repositories; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor repositories[%i] of type nexus_rest_api_ns0_repository_route_resource...\n", i);
#endif
      freeNs0Repository_route_member_repoType(&(_repositoryRouteResource->repositories[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositories of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    free(_repositoryRouteResource->repositories);
  }
  if (_repositoryRouteResource->groupId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupId of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    freeXsStringType(_repositoryRouteResource->groupId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupId of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    free(_repositoryRouteResource->groupId);
  }
  if (_repositoryRouteResource->ruleType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ruleType of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    freeXsStringType(_repositoryRouteResource->ruleType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ruleType of type nexus_rest_api_ns0_repository_route_resource...\n");
#endif
    free(_repositoryRouteResource->ruleType);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_route_resource_M */
#ifndef DEF_nexus_rest_api_ns0_repositoryRouteResourceResponse_M
#define DEF_nexus_rest_api_ns0_repositoryRouteResourceResponse_M

/**
 * Reads a RepositoryRouteResourceResponse element from XML. The element to be read is "repo-route", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryRouteResourceResponse *xml_read_nexus_rest_api_ns0_repositoryRouteResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Repo_routeElement(reader);
}

/**
 * Writes a RepositoryRouteResourceResponse to XML under element name "repo-route".
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_repositoryRouteResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse) {
  return xmlTextWriterWriteNs0Repo_routeElementNS(writer, _repositoryRouteResourceResponse, 1);
}

/**
 * Frees a RepositoryRouteResourceResponse.
 *
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryRouteResourceResponse(struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse) {
  freeNs0RepositoryRouteResourceResponseType(_repositoryRouteResourceResponse);
  free(_repositoryRouteResourceResponse);
}

/**
 * Reads a RepositoryRouteResourceResponse element from XML. The element to be read is "repo-route", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RepositoryRouteResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryRouteResourceResponse *xmlTextReaderReadNs0Repo_routeElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "repo-route", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}repo-route.\n");
#endif
    _repositoryRouteResourceResponse = xmlTextReaderReadNs0RepositoryRouteResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_repositoryRouteResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}repo-route failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}repo-route failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _repositoryRouteResourceResponse;
}

/**
 * Writes a RepositoryRouteResourceResponse to XML under element name "repo-route".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repo_routeElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse) {
  return xmlTextWriterWriteNs0Repo_routeElementNS(writer, _repositoryRouteResourceResponse, 0);
}

/**
 * Writes a RepositoryRouteResourceResponse to XML under element name "repo-route".
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repo_routeElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repo-route", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}repo-route. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}repositoryRouteResourceResponse for root element {}repo-route...\n");
#endif
  status = xmlTextWriterWriteNs0RepositoryRouteResourceResponseType(writer, _repositoryRouteResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}repo-route. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}repo-route. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RepositoryRouteResourceResponse.
 *
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse whose children are to be free.
 */
static void freeNs0Repo_routeElement(struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse) {
  freeNs0RepositoryRouteResourceResponseType(_repositoryRouteResourceResponse);
}

/**
 * Reads a RepositoryRouteResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryRouteResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryRouteResourceResponse *xmlTextReaderReadNs0RepositoryRouteResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_repositoryRouteResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RepositoryRouteResourceResponseType(_repositoryRouteResourceResponse);
        free(_repositoryRouteResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}repository-route-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_route_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}repository-route-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryRouteResourceResponseType(_repositoryRouteResourceResponse);
          free(_repositoryRouteResourceResponse);
          return NULL;
        }

        _repositoryRouteResourceResponse->data = ((struct nexus_rest_api_ns0_repository_route_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repositoryRouteResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repositoryRouteResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryRouteResourceResponse;
}

/**
 * Writes a RepositoryRouteResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RepositoryRouteResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryRouteResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-route-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_route_resourceType(writer, (_repositoryRouteResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-route-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryRouteResourceResponse.
 *
 * @param _repositoryRouteResourceResponse The RepositoryRouteResourceResponse to free.
 */
static void freeNs0RepositoryRouteResourceResponseType(struct nexus_rest_api_ns0_repositoryRouteResourceResponse *_repositoryRouteResourceResponse) {
  int i;
  if (_repositoryRouteResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_repositoryRouteResourceResponse...\n");
#endif
    freeNs0Repository_route_resourceType(_repositoryRouteResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_repositoryRouteResourceResponse...\n");
#endif
    free(_repositoryRouteResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repositoryRouteResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_repository_status_M
#define DEF_nexus_rest_api_ns0_repository_status_M

/**
 * Reads a RepositoryStatusResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryStatusResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_status *xmlTextReaderReadNs0Repository_statusType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_status *_repositoryStatusResource = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_status));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_statusType(_repositoryStatusResource);
        free(_repositoryStatusResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "format", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}format of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->format = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "proxyMode", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}proxyMode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}proxyMode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->proxyMode = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repoType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repoType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->repoType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "dependentRepos", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}dependentRepos...\n");
#endif
          //start wrapper element "{}dependentRepos"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Repository_statusType(_repositoryStatusResource);
              free(_repositoryStatusResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "dependentRepoItem", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}dependentRepoItem of type {}repository-dependent-status.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_dependent_statusType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}dependentRepoItem of type {}repository-dependent-status.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->dependentRepos = realloc(_repositoryStatusResource->dependentRepos, (_repositoryStatusResource->_sizeof_dependentRepos + 1) * sizeof(struct nexus_rest_api_ns0_repository_dependent_status));
        memcpy(&(_repositoryStatusResource->dependentRepos[_repositoryStatusResource->_sizeof_dependentRepos++]), _child_accessor, sizeof(struct nexus_rest_api_ns0_repository_dependent_status));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}dependentRepos.\n");
#endif
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }
        else {
          //end wrapper element "{}dependentRepos"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "remoteStatus", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}remoteStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}remoteStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->remoteStatus = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "localStatus", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}localStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}localStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->localStatus = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_statusType(_repositoryStatusResource);
          free(_repositoryStatusResource);
          return NULL;
        }

        _repositoryStatusResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-status.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-status. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryStatusResource;
}

/**
 * Writes a RepositoryStatusResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResource The RepositoryStatusResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_statusType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_status *_repositoryStatusResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryStatusResource->format != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "format", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}format...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryStatusResource->format));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}format. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryStatusResource->proxyMode != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "proxyMode", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}proxyMode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}proxyMode...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryStatusResource->proxyMode));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}proxyMode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}proxyMode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryStatusResource->repoType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repoType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repoType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryStatusResource->repoType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repoType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryStatusResource->dependentRepos != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "dependentRepos", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}dependentRepos. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _repositoryStatusResource->_sizeof_dependentRepos; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "dependentRepoItem", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}dependentRepoItem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-dependent-status for element {}dependentRepoItem...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_dependent_statusType(writer, &(_repositoryStatusResource->dependentRepos[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-dependent-status for element {}dependentRepoItem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}dependentRepoItem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryStatusResource->dependentRepos != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}dependentRepos. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryStatusResource->remoteStatus != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "remoteStatus", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}remoteStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}remoteStatus...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryStatusResource->remoteStatus));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}remoteStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}remoteStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryStatusResource->localStatus != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "localStatus", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}localStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}localStatus...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryStatusResource->localStatus));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}localStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}localStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryStatusResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryStatusResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryStatusResource.
 *
 * @param _repositoryStatusResource The RepositoryStatusResource to free.
 */
static void freeNs0Repository_statusType(struct nexus_rest_api_ns0_repository_status *_repositoryStatusResource) {
  int i;
  if (_repositoryStatusResource->format != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor format of type nexus_rest_api_ns0_repository_status...\n");
#endif
    freeXsStringType(_repositoryStatusResource->format);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor format of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->format);
  }
  if (_repositoryStatusResource->proxyMode != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor proxyMode of type nexus_rest_api_ns0_repository_status...\n");
#endif
    freeXsStringType(_repositoryStatusResource->proxyMode);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor proxyMode of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->proxyMode);
  }
  if (_repositoryStatusResource->repoType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repoType of type nexus_rest_api_ns0_repository_status...\n");
#endif
    freeXsStringType(_repositoryStatusResource->repoType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repoType of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->repoType);
  }
  if (_repositoryStatusResource->dependentRepos != NULL) {
    for (i = 0; i < _repositoryStatusResource->_sizeof_dependentRepos; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor dependentRepos[%i] of type nexus_rest_api_ns0_repository_status...\n", i);
#endif
      freeNs0Repository_dependent_statusType(&(_repositoryStatusResource->dependentRepos[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor dependentRepos of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->dependentRepos);
  }
  if (_repositoryStatusResource->remoteStatus != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor remoteStatus of type nexus_rest_api_ns0_repository_status...\n");
#endif
    freeXsStringType(_repositoryStatusResource->remoteStatus);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor remoteStatus of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->remoteStatus);
  }
  if (_repositoryStatusResource->localStatus != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor localStatus of type nexus_rest_api_ns0_repository_status...\n");
#endif
    freeXsStringType(_repositoryStatusResource->localStatus);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor localStatus of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->localStatus);
  }
  if (_repositoryStatusResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_status...\n");
#endif
    freeXsStringType(_repositoryStatusResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_status...\n");
#endif
    free(_repositoryStatusResource->id);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_status_M */
#ifndef DEF_nexus_rest_api_ns0_repositoryStatusResourceResponse_M
#define DEF_nexus_rest_api_ns0_repositoryStatusResourceResponse_M

/**
 * Reads a RepositoryStatusResourceResponse element from XML. The element to be read is "repository-status", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryStatusResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryStatusResourceResponse *xml_read_nexus_rest_api_ns0_repositoryStatusResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Repository_statusElement(reader);
}

/**
 * Writes a RepositoryStatusResourceResponse to XML under element name "repository-status".
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_repositoryStatusResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse) {
  return xmlTextWriterWriteNs0Repository_statusElementNS(writer, _repositoryStatusResourceResponse, 1);
}

/**
 * Frees a RepositoryStatusResourceResponse.
 *
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryStatusResourceResponse(struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse) {
  freeNs0RepositoryStatusResourceResponseType(_repositoryStatusResourceResponse);
  free(_repositoryStatusResourceResponse);
}

/**
 * Reads a RepositoryStatusResourceResponse element from XML. The element to be read is "repository-status", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RepositoryStatusResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryStatusResourceResponse *xmlTextReaderReadNs0Repository_statusElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "repository-status", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}repository-status.\n");
#endif
    _repositoryStatusResourceResponse = xmlTextReaderReadNs0RepositoryStatusResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_repositoryStatusResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}repository-status failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}repository-status failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _repositoryStatusResourceResponse;
}

/**
 * Writes a RepositoryStatusResourceResponse to XML under element name "repository-status".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repository_statusElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse) {
  return xmlTextWriterWriteNs0Repository_statusElementNS(writer, _repositoryStatusResourceResponse, 0);
}

/**
 * Writes a RepositoryStatusResourceResponse to XML under element name "repository-status".
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repository_statusElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repository-status", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}repository-status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}repositoryStatusResourceResponse for root element {}repository-status...\n");
#endif
  status = xmlTextWriterWriteNs0RepositoryStatusResourceResponseType(writer, _repositoryStatusResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}repository-status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}repository-status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RepositoryStatusResourceResponse.
 *
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse whose children are to be free.
 */
static void freeNs0Repository_statusElement(struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse) {
  freeNs0RepositoryStatusResourceResponseType(_repositoryStatusResourceResponse);
}

/**
 * Reads a RepositoryStatusResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryStatusResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryStatusResourceResponse *xmlTextReaderReadNs0RepositoryStatusResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_repositoryStatusResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RepositoryStatusResourceResponseType(_repositoryStatusResourceResponse);
        free(_repositoryStatusResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}repository-status.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_statusType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}repository-status.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryStatusResourceResponseType(_repositoryStatusResourceResponse);
          free(_repositoryStatusResourceResponse);
          return NULL;
        }

        _repositoryStatusResourceResponse->data = ((struct nexus_rest_api_ns0_repository_status*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repositoryStatusResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repositoryStatusResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryStatusResourceResponse;
}

/**
 * Writes a RepositoryStatusResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RepositoryStatusResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryStatusResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-status for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_statusType(writer, (_repositoryStatusResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-status for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryStatusResourceResponse.
 *
 * @param _repositoryStatusResourceResponse The RepositoryStatusResourceResponse to free.
 */
static void freeNs0RepositoryStatusResourceResponseType(struct nexus_rest_api_ns0_repositoryStatusResourceResponse *_repositoryStatusResourceResponse) {
  int i;
  if (_repositoryStatusResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_repositoryStatusResourceResponse...\n");
#endif
    freeNs0Repository_statusType(_repositoryStatusResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_repositoryStatusResourceResponse...\n");
#endif
    free(_repositoryStatusResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repositoryStatusResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_repository_target_resource_M
#define DEF_nexus_rest_api_ns0_repository_target_resource_M

/**
 * Reads a RepositoryTargetResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryTargetResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repository_target_resource *xmlTextReaderReadNs0Repository_target_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repository_target_resource *_repositoryTargetResource = calloc(1, sizeof(struct nexus_rest_api_ns0_repository_target_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_target_resourceType(_repositoryTargetResource);
        free(_repositoryTargetResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_target_resourceType(_repositoryTargetResource);
          free(_repositoryTargetResource);
          return NULL;
        }

        _repositoryTargetResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_target_resourceType(_repositoryTargetResource);
          free(_repositoryTargetResource);
          return NULL;
        }

        _repositoryTargetResource->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_target_resourceType(_repositoryTargetResource);
          free(_repositoryTargetResource);
          return NULL;
        }

        _repositoryTargetResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "patterns", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}patterns...\n");
#endif
          //start wrapper element "{}patterns"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Repository_target_resourceType(_repositoryTargetResource);
              free(_repositoryTargetResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "pattern", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}pattern of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}pattern of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_target_resourceType(_repositoryTargetResource);
          free(_repositoryTargetResource);
          return NULL;
        }

        _repositoryTargetResource->patterns = realloc(_repositoryTargetResource->patterns, (_repositoryTargetResource->_sizeof_patterns + 1) * sizeof(xmlChar));
        memcpy(&(_repositoryTargetResource->patterns[_repositoryTargetResource->_sizeof_patterns++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}patterns.\n");
#endif
          freeNs0Repository_target_resourceType(_repositoryTargetResource);
          free(_repositoryTargetResource);
          return NULL;
        }
        else {
          //end wrapper element "{}patterns"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contentClass", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contentClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contentClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_target_resourceType(_repositoryTargetResource);
          free(_repositoryTargetResource);
          return NULL;
        }

        _repositoryTargetResource->contentClass = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-target-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-target-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryTargetResource;
}

/**
 * Writes a RepositoryTargetResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResource The RepositoryTargetResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_target_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repository_target_resource *_repositoryTargetResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryTargetResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryTargetResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryTargetResource->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryTargetResource->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryTargetResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryTargetResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryTargetResource->patterns != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "patterns", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}patterns. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _repositoryTargetResource->_sizeof_patterns; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pattern", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}pattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}pattern...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_repositoryTargetResource->patterns[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}pattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}pattern. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_repositoryTargetResource->patterns != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}patterns. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryTargetResource->contentClass != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contentClass", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contentClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contentClass...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryTargetResource->contentClass));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contentClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contentClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryTargetResource.
 *
 * @param _repositoryTargetResource The RepositoryTargetResource to free.
 */
static void freeNs0Repository_target_resourceType(struct nexus_rest_api_ns0_repository_target_resource *_repositoryTargetResource) {
  int i;
  if (_repositoryTargetResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    freeXsStringType(_repositoryTargetResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    free(_repositoryTargetResource->id);
  }
  if (_repositoryTargetResource->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    freeXsStringType(_repositoryTargetResource->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    free(_repositoryTargetResource->resourceURI);
  }
  if (_repositoryTargetResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    freeXsStringType(_repositoryTargetResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    free(_repositoryTargetResource->name);
  }
  if (_repositoryTargetResource->patterns != NULL) {
    for (i = 0; i < _repositoryTargetResource->_sizeof_patterns; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor patterns[%i] of type nexus_rest_api_ns0_repository_target_resource...\n", i);
#endif
      freeXsStringType(&(_repositoryTargetResource->patterns[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor patterns of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    free(_repositoryTargetResource->patterns);
  }
  if (_repositoryTargetResource->contentClass != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contentClass of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    freeXsStringType(_repositoryTargetResource->contentClass);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contentClass of type nexus_rest_api_ns0_repository_target_resource...\n");
#endif
    free(_repositoryTargetResource->contentClass);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repository_target_resource_M */
#ifndef DEF_nexus_rest_api_ns0_repositoryTargetResourceResponse_M
#define DEF_nexus_rest_api_ns0_repositoryTargetResourceResponse_M

/**
 * Reads a RepositoryTargetResourceResponse element from XML. The element to be read is "repo-target", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RepositoryTargetResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryTargetResourceResponse *xml_read_nexus_rest_api_ns0_repositoryTargetResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Repo_targetElement(reader);
}

/**
 * Writes a RepositoryTargetResourceResponse to XML under element name "repo-target".
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_repositoryTargetResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse) {
  return xmlTextWriterWriteNs0Repo_targetElementNS(writer, _repositoryTargetResourceResponse, 1);
}

/**
 * Frees a RepositoryTargetResourceResponse.
 *
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to free.
 */
void free_nexus_rest_api_ns0_repositoryTargetResourceResponse(struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse) {
  freeNs0RepositoryTargetResourceResponseType(_repositoryTargetResourceResponse);
  free(_repositoryTargetResourceResponse);
}

/**
 * Reads a RepositoryTargetResourceResponse element from XML. The element to be read is "repo-target", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RepositoryTargetResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_repositoryTargetResourceResponse *xmlTextReaderReadNs0Repo_targetElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "repo-target", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}repo-target.\n");
#endif
    _repositoryTargetResourceResponse = xmlTextReaderReadNs0RepositoryTargetResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_repositoryTargetResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}repo-target failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}repo-target failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _repositoryTargetResourceResponse;
}

/**
 * Writes a RepositoryTargetResourceResponse to XML under element name "repo-target".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repo_targetElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse) {
  return xmlTextWriterWriteNs0Repo_targetElementNS(writer, _repositoryTargetResourceResponse, 0);
}

/**
 * Writes a RepositoryTargetResourceResponse to XML under element name "repo-target".
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Repo_targetElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repo-target", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}repo-target. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}repositoryTargetResourceResponse for root element {}repo-target...\n");
#endif
  status = xmlTextWriterWriteNs0RepositoryTargetResourceResponseType(writer, _repositoryTargetResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}repo-target. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}repo-target. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RepositoryTargetResourceResponse.
 *
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse whose children are to be free.
 */
static void freeNs0Repo_targetElement(struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse) {
  freeNs0RepositoryTargetResourceResponseType(_repositoryTargetResourceResponse);
}

/**
 * Reads a RepositoryTargetResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryTargetResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_repositoryTargetResourceResponse *xmlTextReaderReadNs0RepositoryTargetResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_repositoryTargetResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RepositoryTargetResourceResponseType(_repositoryTargetResourceResponse);
        free(_repositoryTargetResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}repository-target-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_target_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}repository-target-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryTargetResourceResponseType(_repositoryTargetResourceResponse);
          free(_repositoryTargetResourceResponse);
          return NULL;
        }

        _repositoryTargetResourceResponse->data = ((struct nexus_rest_api_ns0_repository_target_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repositoryTargetResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repositoryTargetResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryTargetResourceResponse;
}

/**
 * Writes a RepositoryTargetResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RepositoryTargetResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryTargetResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-target-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_target_resourceType(writer, (_repositoryTargetResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-target-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryTargetResourceResponse.
 *
 * @param _repositoryTargetResourceResponse The RepositoryTargetResourceResponse to free.
 */
static void freeNs0RepositoryTargetResourceResponseType(struct nexus_rest_api_ns0_repositoryTargetResourceResponse *_repositoryTargetResourceResponse) {
  int i;
  if (_repositoryTargetResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_repositoryTargetResourceResponse...\n");
#endif
    freeNs0Repository_target_resourceType(_repositoryTargetResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_repositoryTargetResourceResponse...\n");
#endif
    free(_repositoryTargetResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_repositoryTargetResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_rest_api_settings_M
#define DEF_nexus_rest_api_ns0_rest_api_settings_M

/**
 * Reads a RestApiSettings from XML. The reader is assumed to be at the start element.
 *
 * @return the RestApiSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_rest_api_settings *xmlTextReaderReadNs0Rest_api_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_rest_api_settings *_restApiSettings = calloc(1, sizeof(struct nexus_rest_api_ns0_rest_api_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Rest_api_settingsType(_restApiSettings);
        free(_restApiSettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "uiTimeout", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}uiTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}uiTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Rest_api_settingsType(_restApiSettings);
          free(_restApiSettings);
          return NULL;
        }

        _restApiSettings->uiTimeout = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "forceBaseUrl", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}forceBaseUrl of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}forceBaseUrl of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Rest_api_settingsType(_restApiSettings);
          free(_restApiSettings);
          return NULL;
        }

        _restApiSettings->forceBaseUrl = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "baseUrl", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}baseUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}baseUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Rest_api_settingsType(_restApiSettings);
          free(_restApiSettings);
          return NULL;
        }

        _restApiSettings->baseUrl = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}rest-api-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}rest-api-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _restApiSettings;
}

/**
 * Writes a RestApiSettings to XML.
 *
 * @param writer The XML writer.
 * @param _restApiSettings The RestApiSettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Rest_api_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_rest_api_settings *_restApiSettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "uiTimeout", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}uiTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}uiTimeout...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_restApiSettings->uiTimeout));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}uiTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}uiTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "forceBaseUrl", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}forceBaseUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}forceBaseUrl...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_restApiSettings->forceBaseUrl));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}forceBaseUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}forceBaseUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_restApiSettings->baseUrl != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "baseUrl", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}baseUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}baseUrl...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_restApiSettings->baseUrl));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}baseUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}baseUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RestApiSettings.
 *
 * @param _restApiSettings The RestApiSettings to free.
 */
static void freeNs0Rest_api_settingsType(struct nexus_rest_api_ns0_rest_api_settings *_restApiSettings) {
  int i;
  if (_restApiSettings->baseUrl != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor baseUrl of type nexus_rest_api_ns0_rest_api_settings...\n");
#endif
    freeXsStringType(_restApiSettings->baseUrl);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor baseUrl of type nexus_rest_api_ns0_rest_api_settings...\n");
#endif
    free(_restApiSettings->baseUrl);
  }
}
#endif /* DEF_nexus_rest_api_ns0_rest_api_settings_M */
#ifndef DEF_nexus_rest_api_ns0_scheduled_service_base_resource_M
#define DEF_nexus_rest_api_ns0_scheduled_service_base_resource_M

/**
 * Reads a ScheduledServiceBaseResource from XML. The reader is assumed to be at the start element.
 *
 * @return the ScheduledServiceBaseResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_scheduled_service_base_resource *xmlTextReaderReadNs0Scheduled_service_base_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_scheduled_service_base_resource *_scheduledServiceBaseResource = calloc(1, sizeof(struct nexus_rest_api_ns0_scheduled_service_base_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
        free(_scheduledServiceBaseResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "schedule", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}schedule of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}schedule of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->schedule = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "alertEmail", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}alertEmail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}alertEmail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->alertEmail = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "properties", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}properties...\n");
#endif
          //start wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
              free(_scheduledServiceBaseResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "scheduled-task-property", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}scheduled-task-property of type {}scheduled-service-property-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Scheduled_service_property_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}scheduled-task-property of type {}scheduled-service-property-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->properties = realloc(_scheduledServiceBaseResource->properties, (_scheduledServiceBaseResource->_sizeof_properties + 1) * sizeof(struct nexus_rest_api_ns0_scheduled_service_property_resource));
        memcpy(&(_scheduledServiceBaseResource->properties[_scheduledServiceBaseResource->_sizeof_properties++]), _child_accessor, sizeof(struct nexus_rest_api_ns0_scheduled_service_property_resource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}properties.\n");
#endif
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }
        else {
          //end wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->enabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "typeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_base_resourceType(_scheduledServiceBaseResource);
          free(_scheduledServiceBaseResource);
          return NULL;
        }

        _scheduledServiceBaseResource->typeId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}scheduled-service-base-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}scheduled-service-base-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _scheduledServiceBaseResource;
}

/**
 * Writes a ScheduledServiceBaseResource to XML.
 *
 * @param writer The XML writer.
 * @param _scheduledServiceBaseResource The ScheduledServiceBaseResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Scheduled_service_base_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduled_service_base_resource *_scheduledServiceBaseResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_scheduledServiceBaseResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServiceBaseResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_scheduledServiceBaseResource->schedule != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "schedule", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}schedule. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}schedule...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServiceBaseResource->schedule));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}schedule. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}schedule. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_scheduledServiceBaseResource->alertEmail != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "alertEmail", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}alertEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}alertEmail...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServiceBaseResource->alertEmail));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}alertEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}alertEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_scheduledServiceBaseResource->properties != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "properties", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _scheduledServiceBaseResource->_sizeof_properties; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "scheduled-task-property", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}scheduled-task-property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}scheduled-service-property-resource for element {}scheduled-task-property...\n", status);
#endif
    status = xmlTextWriterWriteNs0Scheduled_service_property_resourceType(writer, &(_scheduledServiceBaseResource->properties[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}scheduled-service-property-resource for element {}scheduled-task-property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}scheduled-task-property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_scheduledServiceBaseResource->properties != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_scheduledServiceBaseResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServiceBaseResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_scheduledServiceBaseResource->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_scheduledServiceBaseResource->typeId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "typeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}typeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServiceBaseResource->typeId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ScheduledServiceBaseResource.
 *
 * @param _scheduledServiceBaseResource The ScheduledServiceBaseResource to free.
 */
static void freeNs0Scheduled_service_base_resourceType(struct nexus_rest_api_ns0_scheduled_service_base_resource *_scheduledServiceBaseResource) {
  int i;
  if (_scheduledServiceBaseResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    freeXsStringType(_scheduledServiceBaseResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    free(_scheduledServiceBaseResource->name);
  }
  if (_scheduledServiceBaseResource->schedule != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor schedule of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    freeXsStringType(_scheduledServiceBaseResource->schedule);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor schedule of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    free(_scheduledServiceBaseResource->schedule);
  }
  if (_scheduledServiceBaseResource->alertEmail != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor alertEmail of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    freeXsStringType(_scheduledServiceBaseResource->alertEmail);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor alertEmail of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    free(_scheduledServiceBaseResource->alertEmail);
  }
  if (_scheduledServiceBaseResource->properties != NULL) {
    for (i = 0; i < _scheduledServiceBaseResource->_sizeof_properties; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor properties[%i] of type nexus_rest_api_ns0_scheduled_service_base_resource...\n", i);
#endif
      freeNs0Scheduled_service_property_resourceType(&(_scheduledServiceBaseResource->properties[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor properties of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    free(_scheduledServiceBaseResource->properties);
  }
  if (_scheduledServiceBaseResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    freeXsStringType(_scheduledServiceBaseResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    free(_scheduledServiceBaseResource->id);
  }
  if (_scheduledServiceBaseResource->typeId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor typeId of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    freeXsStringType(_scheduledServiceBaseResource->typeId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor typeId of type nexus_rest_api_ns0_scheduled_service_base_resource...\n");
#endif
    free(_scheduledServiceBaseResource->typeId);
  }
}
#endif /* DEF_nexus_rest_api_ns0_scheduled_service_base_resource_M */
#ifndef DEF_nexus_rest_api_ns0_scheduled_service_property_resource_M
#define DEF_nexus_rest_api_ns0_scheduled_service_property_resource_M

/**
 * Reads a ScheduledServicePropertyResource from XML. The reader is assumed to be at the start element.
 *
 * @return the ScheduledServicePropertyResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_scheduled_service_property_resource *xmlTextReaderReadNs0Scheduled_service_property_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_scheduled_service_property_resource *_scheduledServicePropertyResource = calloc(1, sizeof(struct nexus_rest_api_ns0_scheduled_service_property_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Scheduled_service_property_resourceType(_scheduledServicePropertyResource);
        free(_scheduledServicePropertyResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_property_resourceType(_scheduledServicePropertyResource);
          free(_scheduledServicePropertyResource);
          return NULL;
        }

        _scheduledServicePropertyResource->key = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "value", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Scheduled_service_property_resourceType(_scheduledServicePropertyResource);
          free(_scheduledServicePropertyResource);
          return NULL;
        }

        _scheduledServicePropertyResource->value = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}scheduled-service-property-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}scheduled-service-property-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _scheduledServicePropertyResource;
}

/**
 * Writes a ScheduledServicePropertyResource to XML.
 *
 * @param writer The XML writer.
 * @param _scheduledServicePropertyResource The ScheduledServicePropertyResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Scheduled_service_property_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduled_service_property_resource *_scheduledServicePropertyResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_scheduledServicePropertyResource->key != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}key...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServicePropertyResource->key));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_scheduledServicePropertyResource->value != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "value", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}value...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_scheduledServicePropertyResource->value));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ScheduledServicePropertyResource.
 *
 * @param _scheduledServicePropertyResource The ScheduledServicePropertyResource to free.
 */
static void freeNs0Scheduled_service_property_resourceType(struct nexus_rest_api_ns0_scheduled_service_property_resource *_scheduledServicePropertyResource) {
  int i;
  if (_scheduledServicePropertyResource->key != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor key of type nexus_rest_api_ns0_scheduled_service_property_resource...\n");
#endif
    freeXsStringType(_scheduledServicePropertyResource->key);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor key of type nexus_rest_api_ns0_scheduled_service_property_resource...\n");
#endif
    free(_scheduledServicePropertyResource->key);
  }
  if (_scheduledServicePropertyResource->value != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor value of type nexus_rest_api_ns0_scheduled_service_property_resource...\n");
#endif
    freeXsStringType(_scheduledServicePropertyResource->value);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor value of type nexus_rest_api_ns0_scheduled_service_property_resource...\n");
#endif
    free(_scheduledServicePropertyResource->value);
  }
}
#endif /* DEF_nexus_rest_api_ns0_scheduled_service_property_resource_M */
#ifndef DEF_nexus_rest_api_ns0_scheduledServiceResourceResponse_M
#define DEF_nexus_rest_api_ns0_scheduledServiceResourceResponse_M

/**
 * Reads a ScheduledServiceResourceResponse element from XML. The element to be read is "scheduled-task", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ScheduledServiceResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_scheduledServiceResourceResponse *xml_read_nexus_rest_api_ns0_scheduledServiceResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Scheduled_taskElement(reader);
}

/**
 * Writes a ScheduledServiceResourceResponse to XML under element name "scheduled-task".
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_scheduledServiceResourceResponse(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse) {
  return xmlTextWriterWriteNs0Scheduled_taskElementNS(writer, _scheduledServiceResourceResponse, 1);
}

/**
 * Frees a ScheduledServiceResourceResponse.
 *
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to free.
 */
void free_nexus_rest_api_ns0_scheduledServiceResourceResponse(struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse) {
  freeNs0ScheduledServiceResourceResponseType(_scheduledServiceResourceResponse);
  free(_scheduledServiceResourceResponse);
}

/**
 * Reads a ScheduledServiceResourceResponse element from XML. The element to be read is "scheduled-task", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ScheduledServiceResourceResponse, or NULL in case of error.
 */
struct nexus_rest_api_ns0_scheduledServiceResourceResponse *xmlTextReaderReadNs0Scheduled_taskElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "scheduled-task", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}scheduled-task.\n");
#endif
    _scheduledServiceResourceResponse = xmlTextReaderReadNs0ScheduledServiceResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_scheduledServiceResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}scheduled-task failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}scheduled-task failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _scheduledServiceResourceResponse;
}

/**
 * Writes a ScheduledServiceResourceResponse to XML under element name "scheduled-task".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Scheduled_taskElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse) {
  return xmlTextWriterWriteNs0Scheduled_taskElementNS(writer, _scheduledServiceResourceResponse, 0);
}

/**
 * Writes a ScheduledServiceResourceResponse to XML under element name "scheduled-task".
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Scheduled_taskElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "scheduled-task", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}scheduled-task. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}scheduledServiceResourceResponse for root element {}scheduled-task...\n");
#endif
  status = xmlTextWriterWriteNs0ScheduledServiceResourceResponseType(writer, _scheduledServiceResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}scheduled-task. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}scheduled-task. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ScheduledServiceResourceResponse.
 *
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse whose children are to be free.
 */
static void freeNs0Scheduled_taskElement(struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse) {
  freeNs0ScheduledServiceResourceResponseType(_scheduledServiceResourceResponse);
}

/**
 * Reads a ScheduledServiceResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the ScheduledServiceResourceResponse, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_scheduledServiceResourceResponse *xmlTextReaderReadNs0ScheduledServiceResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse = calloc(1, sizeof(struct nexus_rest_api_ns0_scheduledServiceResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ScheduledServiceResourceResponseType(_scheduledServiceResourceResponse);
        free(_scheduledServiceResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}scheduled-service-base-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Scheduled_service_base_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}scheduled-service-base-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ScheduledServiceResourceResponseType(_scheduledServiceResourceResponse);
          free(_scheduledServiceResourceResponse);
          return NULL;
        }

        _scheduledServiceResourceResponse->data = ((struct nexus_rest_api_ns0_scheduled_service_base_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}scheduledServiceResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}scheduledServiceResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _scheduledServiceResourceResponse;
}

/**
 * Writes a ScheduledServiceResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ScheduledServiceResourceResponseType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_scheduledServiceResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}scheduled-service-base-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Scheduled_service_base_resourceType(writer, (_scheduledServiceResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}scheduled-service-base-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ScheduledServiceResourceResponse.
 *
 * @param _scheduledServiceResourceResponse The ScheduledServiceResourceResponse to free.
 */
static void freeNs0ScheduledServiceResourceResponseType(struct nexus_rest_api_ns0_scheduledServiceResourceResponse *_scheduledServiceResourceResponse) {
  int i;
  if (_scheduledServiceResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_scheduledServiceResourceResponse...\n");
#endif
    freeNs0Scheduled_service_base_resourceType(_scheduledServiceResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_scheduledServiceResourceResponse...\n");
#endif
    free(_scheduledServiceResourceResponse->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_scheduledServiceResourceResponse_M */
#ifndef DEF_nexus_rest_api_ns0_smtp_settings_M
#define DEF_nexus_rest_api_ns0_smtp_settings_M

/**
 * Reads a SmtpSettings from XML. The reader is assumed to be at the start element.
 *
 * @return the SmtpSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_smtp_settings *xmlTextReaderReadNs0Smtp_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_smtp_settings *_smtpSettings = calloc(1, sizeof(struct nexus_rest_api_ns0_smtp_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Smtp_settingsType(_smtpSettings);
        free(_smtpSettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "password", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->password = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->host = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "systemEmailAddress", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}systemEmailAddress of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}systemEmailAddress of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->systemEmailAddress = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "username", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->username = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->port = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "tlsEnabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}tlsEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}tlsEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->tlsEnabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sslEnabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sslEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sslEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settingsType(_smtpSettings);
          free(_smtpSettings);
          return NULL;
        }

        _smtpSettings->sslEnabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}smtp-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}smtp-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _smtpSettings;
}

/**
 * Writes a SmtpSettings to XML.
 *
 * @param writer The XML writer.
 * @param _smtpSettings The SmtpSettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Smtp_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtp_settings *_smtpSettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_smtpSettings->password != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "password", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}password...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettings->password));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettings->host != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}host...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettings->host));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettings->systemEmailAddress != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "systemEmailAddress", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}systemEmailAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}systemEmailAddress...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettings->systemEmailAddress));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}systemEmailAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}systemEmailAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettings->username != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "username", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}username...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettings->username));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}port...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_smtpSettings->port));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "tlsEnabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}tlsEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}tlsEnabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_smtpSettings->tlsEnabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}tlsEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}tlsEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sslEnabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sslEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}sslEnabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_smtpSettings->sslEnabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}sslEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sslEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SmtpSettings.
 *
 * @param _smtpSettings The SmtpSettings to free.
 */
static void freeNs0Smtp_settingsType(struct nexus_rest_api_ns0_smtp_settings *_smtpSettings) {
  int i;
  if (_smtpSettings->password != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor password of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    freeXsStringType(_smtpSettings->password);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor password of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    free(_smtpSettings->password);
  }
  if (_smtpSettings->host != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor host of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    freeXsStringType(_smtpSettings->host);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor host of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    free(_smtpSettings->host);
  }
  if (_smtpSettings->systemEmailAddress != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor systemEmailAddress of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    freeXsStringType(_smtpSettings->systemEmailAddress);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor systemEmailAddress of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    free(_smtpSettings->systemEmailAddress);
  }
  if (_smtpSettings->username != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor username of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    freeXsStringType(_smtpSettings->username);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor username of type nexus_rest_api_ns0_smtp_settings...\n");
#endif
    free(_smtpSettings->username);
  }
}
#endif /* DEF_nexus_rest_api_ns0_smtp_settings_M */
#ifndef DEF_nexus_rest_api_ns0_smtp_settings_resource_M
#define DEF_nexus_rest_api_ns0_smtp_settings_resource_M

/**
 * Reads a SmtpSettingsResource from XML. The reader is assumed to be at the start element.
 *
 * @return the SmtpSettingsResource, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_smtp_settings_resource *xmlTextReaderReadNs0Smtp_settings_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_smtp_settings_resource *_smtpSettingsResource = calloc(1, sizeof(struct nexus_rest_api_ns0_smtp_settings_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
        free(_smtpSettingsResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "testEmail", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}testEmail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}testEmail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->testEmail = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->host = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "password", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->password = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "tlsEnabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}tlsEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}tlsEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->tlsEnabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "systemEmailAddress", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}systemEmailAddress of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}systemEmailAddress of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->systemEmailAddress = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sslEnabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sslEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sslEnabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->sslEnabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "username", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->username = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Smtp_settings_resourceType(_smtpSettingsResource);
          free(_smtpSettingsResource);
          return NULL;
        }

        _smtpSettingsResource->port = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}smtp-settings-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}smtp-settings-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _smtpSettingsResource;
}

/**
 * Writes a SmtpSettingsResource to XML.
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResource The SmtpSettingsResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Smtp_settings_resourceType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtp_settings_resource *_smtpSettingsResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_smtpSettingsResource->testEmail != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "testEmail", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}testEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}testEmail...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettingsResource->testEmail));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}testEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}testEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettingsResource->host != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}host...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettingsResource->host));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettingsResource->password != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "password", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}password...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettingsResource->password));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "tlsEnabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}tlsEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}tlsEnabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_smtpSettingsResource->tlsEnabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}tlsEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}tlsEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettingsResource->systemEmailAddress != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "systemEmailAddress", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}systemEmailAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}systemEmailAddress...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettingsResource->systemEmailAddress));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}systemEmailAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}systemEmailAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sslEnabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sslEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}sslEnabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_smtpSettingsResource->sslEnabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}sslEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sslEnabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_smtpSettingsResource->username != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "username", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}username...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_smtpSettingsResource->username));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}port...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_smtpSettingsResource->port));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SmtpSettingsResource.
 *
 * @param _smtpSettingsResource The SmtpSettingsResource to free.
 */
static void freeNs0Smtp_settings_resourceType(struct nexus_rest_api_ns0_smtp_settings_resource *_smtpSettingsResource) {
  int i;
  if (_smtpSettingsResource->testEmail != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor testEmail of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    freeXsStringType(_smtpSettingsResource->testEmail);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor testEmail of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    free(_smtpSettingsResource->testEmail);
  }
  if (_smtpSettingsResource->host != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor host of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    freeXsStringType(_smtpSettingsResource->host);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor host of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    free(_smtpSettingsResource->host);
  }
  if (_smtpSettingsResource->password != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor password of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    freeXsStringType(_smtpSettingsResource->password);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor password of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    free(_smtpSettingsResource->password);
  }
  if (_smtpSettingsResource->systemEmailAddress != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor systemEmailAddress of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    freeXsStringType(_smtpSettingsResource->systemEmailAddress);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor systemEmailAddress of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    free(_smtpSettingsResource->systemEmailAddress);
  }
  if (_smtpSettingsResource->username != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor username of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    freeXsStringType(_smtpSettingsResource->username);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor username of type nexus_rest_api_ns0_smtp_settings_resource...\n");
#endif
    free(_smtpSettingsResource->username);
  }
}
#endif /* DEF_nexus_rest_api_ns0_smtp_settings_resource_M */
#ifndef DEF_nexus_rest_api_ns0_smtpSettingsResourceRequest_M
#define DEF_nexus_rest_api_ns0_smtpSettingsResourceRequest_M

/**
 * Reads a SmtpSettingsResourceRequest element from XML. The element to be read is "smtp-settings-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SmtpSettingsResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_smtpSettingsResourceRequest *xml_read_nexus_rest_api_ns0_smtpSettingsResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Smtp_settings_requestElement(reader);
}

/**
 * Writes a SmtpSettingsResourceRequest to XML under element name "smtp-settings-request".
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_smtpSettingsResourceRequest(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest) {
  return xmlTextWriterWriteNs0Smtp_settings_requestElementNS(writer, _smtpSettingsResourceRequest, 1);
}

/**
 * Frees a SmtpSettingsResourceRequest.
 *
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to free.
 */
void free_nexus_rest_api_ns0_smtpSettingsResourceRequest(struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest) {
  freeNs0SmtpSettingsResourceRequestType(_smtpSettingsResourceRequest);
  free(_smtpSettingsResourceRequest);
}

/**
 * Reads a SmtpSettingsResourceRequest element from XML. The element to be read is "smtp-settings-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SmtpSettingsResourceRequest, or NULL in case of error.
 */
struct nexus_rest_api_ns0_smtpSettingsResourceRequest *xmlTextReaderReadNs0Smtp_settings_requestElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "smtp-settings-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}smtp-settings-request.\n");
#endif
    _smtpSettingsResourceRequest = xmlTextReaderReadNs0SmtpSettingsResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_smtpSettingsResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}smtp-settings-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}smtp-settings-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _smtpSettingsResourceRequest;
}

/**
 * Writes a SmtpSettingsResourceRequest to XML under element name "smtp-settings-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Smtp_settings_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest) {
  return xmlTextWriterWriteNs0Smtp_settings_requestElementNS(writer, _smtpSettingsResourceRequest, 0);
}

/**
 * Writes a SmtpSettingsResourceRequest to XML under element name "smtp-settings-request".
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Smtp_settings_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "smtp-settings-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}smtp-settings-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}smtpSettingsResourceRequest for root element {}smtp-settings-request...\n");
#endif
  status = xmlTextWriterWriteNs0SmtpSettingsResourceRequestType(writer, _smtpSettingsResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}smtp-settings-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}smtp-settings-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SmtpSettingsResourceRequest.
 *
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest whose children are to be free.
 */
static void freeNs0Smtp_settings_requestElement(struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest) {
  freeNs0SmtpSettingsResourceRequestType(_smtpSettingsResourceRequest);
}

/**
 * Reads a SmtpSettingsResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the SmtpSettingsResourceRequest, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_smtpSettingsResourceRequest *xmlTextReaderReadNs0SmtpSettingsResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest = calloc(1, sizeof(struct nexus_rest_api_ns0_smtpSettingsResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SmtpSettingsResourceRequestType(_smtpSettingsResourceRequest);
        free(_smtpSettingsResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}smtp-settings-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Smtp_settings_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}smtp-settings-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SmtpSettingsResourceRequestType(_smtpSettingsResourceRequest);
          free(_smtpSettingsResourceRequest);
          return NULL;
        }

        _smtpSettingsResourceRequest->data = ((struct nexus_rest_api_ns0_smtp_settings_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}smtpSettingsResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}smtpSettingsResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _smtpSettingsResourceRequest;
}

/**
 * Writes a SmtpSettingsResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SmtpSettingsResourceRequestType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_smtpSettingsResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}smtp-settings-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Smtp_settings_resourceType(writer, (_smtpSettingsResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}smtp-settings-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SmtpSettingsResourceRequest.
 *
 * @param _smtpSettingsResourceRequest The SmtpSettingsResourceRequest to free.
 */
static void freeNs0SmtpSettingsResourceRequestType(struct nexus_rest_api_ns0_smtpSettingsResourceRequest *_smtpSettingsResourceRequest) {
  int i;
  if (_smtpSettingsResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_smtpSettingsResourceRequest...\n");
#endif
    freeNs0Smtp_settings_resourceType(_smtpSettingsResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_smtpSettingsResourceRequest...\n");
#endif
    free(_smtpSettingsResourceRequest->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_smtpSettingsResourceRequest_M */
#ifndef DEF_nexus_rest_api_ns0_system_notification_settings_M
#define DEF_nexus_rest_api_ns0_system_notification_settings_M

/**
 * Reads a SystemNotificationSettings from XML. The reader is assumed to be at the start element.
 *
 * @return the SystemNotificationSettings, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_system_notification_settings *xmlTextReaderReadNs0System_notification_settingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_system_notification_settings *_systemNotificationSettings = calloc(1, sizeof(struct nexus_rest_api_ns0_system_notification_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0System_notification_settingsType(_systemNotificationSettings);
        free(_systemNotificationSettings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "roles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}roles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}roles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0System_notification_settingsType(_systemNotificationSettings);
          free(_systemNotificationSettings);
          return NULL;
        }

        _systemNotificationSettings->roles = realloc(_systemNotificationSettings->roles, (_systemNotificationSettings->_sizeof_roles + 1) * sizeof(xmlChar));
        memcpy(&(_systemNotificationSettings->roles[_systemNotificationSettings->_sizeof_roles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "emailAddresses", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}emailAddresses of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}emailAddresses of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0System_notification_settingsType(_systemNotificationSettings);
          free(_systemNotificationSettings);
          return NULL;
        }

        _systemNotificationSettings->emailAddresses = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0System_notification_settingsType(_systemNotificationSettings);
          free(_systemNotificationSettings);
          return NULL;
        }

        _systemNotificationSettings->enabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}system-notification-settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}system-notification-settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _systemNotificationSettings;
}

/**
 * Writes a SystemNotificationSettings to XML.
 *
 * @param writer The XML writer.
 * @param _systemNotificationSettings The SystemNotificationSettings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0System_notification_settingsType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_system_notification_settings *_systemNotificationSettings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  for (i = 0; i < _systemNotificationSettings->_sizeof_roles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "roles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}roles...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_systemNotificationSettings->roles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_systemNotificationSettings->emailAddresses != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "emailAddresses", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}emailAddresses. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}emailAddresses...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_systemNotificationSettings->emailAddresses));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}emailAddresses. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}emailAddresses. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_systemNotificationSettings->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SystemNotificationSettings.
 *
 * @param _systemNotificationSettings The SystemNotificationSettings to free.
 */
static void freeNs0System_notification_settingsType(struct nexus_rest_api_ns0_system_notification_settings *_systemNotificationSettings) {
  int i;
  if (_systemNotificationSettings->roles != NULL) {
    for (i = 0; i < _systemNotificationSettings->_sizeof_roles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor roles[%i] of type nexus_rest_api_ns0_system_notification_settings...\n", i);
#endif
      freeXsStringType(&(_systemNotificationSettings->roles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor roles of type nexus_rest_api_ns0_system_notification_settings...\n");
#endif
    free(_systemNotificationSettings->roles);
  }
  if (_systemNotificationSettings->emailAddresses != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor emailAddresses of type nexus_rest_api_ns0_system_notification_settings...\n");
#endif
    freeXsStringType(_systemNotificationSettings->emailAddresses);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor emailAddresses of type nexus_rest_api_ns0_system_notification_settings...\n");
#endif
    free(_systemNotificationSettings->emailAddresses);
  }
}
#endif /* DEF_nexus_rest_api_ns0_system_notification_settings_M */
#ifndef DEF_nexus_rest_api_ns0_userAccount_M
#define DEF_nexus_rest_api_ns0_userAccount_M

/**
 * Reads a UserAccount from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccount, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_userAccount *xmlTextReaderReadNs0UserAccountType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_userAccount *_userAccount = calloc(1, sizeof(struct nexus_rest_api_ns0_userAccount));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountType(_userAccount);
        free(_userAccount);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "firstName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->firstName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "lastName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->lastName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "email", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->email = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccount.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccount. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccount;
}

/**
 * Writes a UserAccount to XML.
 *
 * @param writer The XML writer.
 * @param _userAccount The UserAccount to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccount *_userAccount) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userAccount->firstName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "firstName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}firstName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->firstName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userAccount->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userAccount->lastName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "lastName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}lastName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->lastName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userAccount->email != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "email", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}email...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->email));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccount.
 *
 * @param _userAccount The UserAccount to free.
 */
static void freeNs0UserAccountType(struct nexus_rest_api_ns0_userAccount *_userAccount) {
  int i;
  if (_userAccount->firstName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor firstName of type nexus_rest_api_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->firstName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor firstName of type nexus_rest_api_ns0_userAccount...\n");
#endif
    free(_userAccount->firstName);
  }
  if (_userAccount->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type nexus_rest_api_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type nexus_rest_api_ns0_userAccount...\n");
#endif
    free(_userAccount->userId);
  }
  if (_userAccount->lastName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor lastName of type nexus_rest_api_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->lastName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor lastName of type nexus_rest_api_ns0_userAccount...\n");
#endif
    free(_userAccount->lastName);
  }
  if (_userAccount->email != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor email of type nexus_rest_api_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->email);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor email of type nexus_rest_api_ns0_userAccount...\n");
#endif
    free(_userAccount->email);
  }
}
#endif /* DEF_nexus_rest_api_ns0_userAccount_M */
#ifndef DEF_nexus_rest_api_ns0_userAccountRequestResponseWrapper_M
#define DEF_nexus_rest_api_ns0_userAccountRequestResponseWrapper_M

/**
 * Reads a UserAccountRequestResponseWrapper element from XML. The element to be read is "user-account-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountRequestResponseWrapper, or NULL in case of error.
 */
struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *xml_read_nexus_rest_api_ns0_userAccountRequestResponseWrapper(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0User_account_requestElement(reader);
}

/**
 * Writes a UserAccountRequestResponseWrapper to XML under element name "user-account-request".
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_rest_api_ns0_userAccountRequestResponseWrapper(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper) {
  return xmlTextWriterWriteNs0User_account_requestElementNS(writer, _userAccountRequestResponseWrapper, 1);
}

/**
 * Frees a UserAccountRequestResponseWrapper.
 *
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to free.
 */
void free_nexus_rest_api_ns0_userAccountRequestResponseWrapper(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper) {
  freeNs0UserAccountRequestResponseWrapperType(_userAccountRequestResponseWrapper);
  free(_userAccountRequestResponseWrapper);
}

/**
 * Reads a UserAccountRequestResponseWrapper element from XML. The element to be read is "user-account-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserAccountRequestResponseWrapper, or NULL in case of error.
 */
struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *xmlTextReaderReadNs0User_account_requestElement(xmlTextReaderPtr reader) {
  struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "user-account-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}user-account-request.\n");
#endif
    _userAccountRequestResponseWrapper = xmlTextReaderReadNs0UserAccountRequestResponseWrapperType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userAccountRequestResponseWrapper == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}user-account-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}user-account-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userAccountRequestResponseWrapper;
}

/**
 * Writes a UserAccountRequestResponseWrapper to XML under element name "user-account-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_account_requestElement(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper) {
  return xmlTextWriterWriteNs0User_account_requestElementNS(writer, _userAccountRequestResponseWrapper, 0);
}

/**
 * Writes a UserAccountRequestResponseWrapper to XML under element name "user-account-request".
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_account_requestElementNS(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "user-account-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}user-account-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userAccountRequestResponseWrapper for root element {}user-account-request...\n");
#endif
  status = xmlTextWriterWriteNs0UserAccountRequestResponseWrapperType(writer, _userAccountRequestResponseWrapper);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}user-account-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}user-account-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserAccountRequestResponseWrapper.
 *
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper whose children are to be free.
 */
static void freeNs0User_account_requestElement(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper) {
  freeNs0UserAccountRequestResponseWrapperType(_userAccountRequestResponseWrapper);
}

/**
 * Reads a UserAccountRequestResponseWrapper from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccountRequestResponseWrapper, or NULL in case of error.
 */
static struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *xmlTextReaderReadNs0UserAccountRequestResponseWrapperType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper = calloc(1, sizeof(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountRequestResponseWrapperType(_userAccountRequestResponseWrapper);
        free(_userAccountRequestResponseWrapper);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userAccount.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserAccountType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userAccount.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountRequestResponseWrapperType(_userAccountRequestResponseWrapper);
          free(_userAccountRequestResponseWrapper);
          return NULL;
        }

        _userAccountRequestResponseWrapper->data = ((struct nexus_rest_api_ns0_userAccount*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccountRequestResponseWrapper.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccountRequestResponseWrapper. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccountRequestResponseWrapper;
}

/**
 * Writes a UserAccountRequestResponseWrapper to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountRequestResponseWrapperType(xmlTextWriterPtr writer, struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userAccountRequestResponseWrapper->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userAccount for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserAccountType(writer, (_userAccountRequestResponseWrapper->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userAccount for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccountRequestResponseWrapper.
 *
 * @param _userAccountRequestResponseWrapper The UserAccountRequestResponseWrapper to free.
 */
static void freeNs0UserAccountRequestResponseWrapperType(struct nexus_rest_api_ns0_userAccountRequestResponseWrapper *_userAccountRequestResponseWrapper) {
  int i;
  if (_userAccountRequestResponseWrapper->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_rest_api_ns0_userAccountRequestResponseWrapper...\n");
#endif
    freeNs0UserAccountType(_userAccountRequestResponseWrapper->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_rest_api_ns0_userAccountRequestResponseWrapper...\n");
#endif
    free(_userAccountRequestResponseWrapper->data);
  }
}
#endif /* DEF_nexus_rest_api_ns0_userAccountRequestResponseWrapper_M */
